/* doUndoMoveLock.tcc
 */
#ifndef _DOUNDOMOVELOCK_TCC
#define _DOUNDOMOVELOCK_TCC

#include "osl/apply_move/doUndoMoveLock.h"
#include "osl/state/simpleState.h"

template <class State>
void osl::apply_move::DoUndoMoveLock::
init(State& s, osl::Move move)
{
  state = &s;
  assert(state->getTurn() == move.player());
  assert(move.isValid());
  const Position from=move.from();
  const Position to=move.to();
  if (from.isPieceStand())
  {
    assert(state->getPieceAt(to) == Piece::EMPTY());
    cleaner.reset(new DoUndoMoveLockDrop<State>(s,to,move.ptype()));
  }
  else
  {
    assert(state->getPieceAt(from) != Piece::EMPTY());
    const Piece captured=state->getPieceAt(to);
    if (captured != Piece::EMPTY())
    {
      cleaner.reset(new DoUndoMoveLockCapture<State>
		      (s,from,to,captured,move.promoteMask()));
    }
    else
    {
      cleaner.reset(new DoUndoMoveLockSimple<State>
		      (s,from,to,move.promoteMask()));
    }
  }
  state->changeTurn();
}

#endif /* _DOUNDOMOVELOCK_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
