/* threatmatePool.h
 */
#ifndef OSL_BRINKMATE_THREATMATEPOOL_H
#define OSL_BRINKMATE_THREATMATEPOOL_H

#include "osl/move.h"
#include "osl/stl/vector.h"
#include "osl/misc/carray.h"

namespace osl
{
  namespace brinkmate
  {
    /**
     * nominate candidates for threatmate move
     */
    class ThreatmatePool
    {
    public:
      typedef vector<Move> vector_t;
    private:
      CArray<vector_t,Position::SIZE> moves;
    public:
      ThreatmatePool();
      ~ThreatmatePool();
      
      void add(Move, Position king);
      const vector_t& find(Position king) const { return moves[king.index()]; }

      void show() const;
    };
  } // namespace brinkmate
} // namespace osl

#endif /* OSL_BRINKMATE_THREATMATEPOOL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
