// categoryMoveVector.h
#ifndef CATEGORYMOVEVECTOR_H
#define CATEGORYMOVEVECTOR_H

#include "osl/category/categoryEnv.h"
#include "osl/container/moveLogProbVector.h"
#include "osl/stl/slist.h"
#include <string>

namespace osl
{
  namespace category
  {
    namespace analyzer
    {
      struct CategoryMoves
      {
	MoveLogProbVector moves;
	std::string category;
	CategoryMoves(const MoveLogProbVector&, const std::string&);
      };
      class CategoryMoveVector
	: public osl::slist<CategoryMoves>
      {
	class Helper;
	class DetailFinder;
      public:
	CategoryMoveVector();
	~CategoryMoveVector();
	
	template <class Categories>
	void generateAndSet(const CategoryEnv& env);
	template <class Categories>
	void generateAndSetDetailed(const CategoryEnv& env);
      };
    } // namespace analyzer
  } // namespace category
} // namespace osl

#endif /* CATEGORYMOVEVECTOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
