/* breakThreatmate.h
 */
#ifndef OSL_CATEGORY_BREAKTHREATMATE_H
#define OSL_CATEGORY_BREAKTHREATMATE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/search/simpleHashRecord.h"

namespace osl
{
  namespace container
  {
    class MoveLogProbVector;
  }
  namespace category
  {
    using container::MoveLogProbVector;
    struct BreakThreatmate : public SpecialProbabilityCategory
    {
      static const char *getName() { return "BreakThreatmate"; }
      static int minProb() { return 100; }
      static void generateBreakDrop(int limit,
				    const NumEffectState&, Position to,
				    int default_prob, MoveLogProbVector& out);
      static void generateOpenRoad(int limit,
				   const NumEffectState&, Position target,
				   MoveLogProbVector& out);
      static void generateBreak(int limit,
				const NumEffectState&, Move,
				MoveLogProbVector& out);

      static void generate(const CategoryEnv& env, MoveLogProbVector& out) {
	const Player turn = env.state->getTurn();
	if (! env.record)
	  return;
	const Move threatmate_move = env.record->threatmate().threatmateMove(turn);
	if (threatmate_move.isNormal())
	  generateBreak(env.limit, *env.state, threatmate_move, out);
      }
    };
  }
}


#endif /* OSL_CATEGORY_BREAKTHREATMATE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
