#ifndef _CATEGORYFLAGS_H_
#define _CATEGORYFLAGS_H_
#include <iosfwd>
#include <cassert>
#include <cstddef>
namespace osl
{
  namespace category
  {
    struct CategoryFlags
    {
      static const size_t maxCategories = 64;
      unsigned long long data;
      bool isSet(size_t i) const
      {
	assert(i < maxCategories);
	return data & (1uLL << i);
      }
      void set(size_t i)
      {
	assert(i < maxCategories);
	data |= (1uLL << i);
      }
      void clear()
      {
	data = 0;
      }
    };
    std::ostream& operator<<(std::ostream&, CategoryFlags);

  } // namespace category
} // namespace osl

#endif /* _CATEGORYFLAGS_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
