/* escape.h
 */
#ifndef _ESCAPE_H
#define _ESCAPE_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/category/probTable.h"
#include "osl/category/ptypePtypeProbTable.h"
#include "osl/container/moveStack.h"
#include "osl/effect_util/effectUtil.h"
#include <boost/static_assert.hpp>
namespace osl
{
  namespace container
  {
    class MoveLogProbVector;
  }
  namespace category
  {
    using container::MoveLogProbVector;
    /**
     * Escape Τν饹
     */
    struct EscapeCommon
    {
      struct Generator;
    };
    
    /**
     * ̤ escape.
     * դƼ̤Υƥ
     * FIX: 
     * - isInCategory Ǥ乶ϥåƤʤ
     * - capture ϰϤʤΤƨȹ
     *   ͤɤ⤷ʤ
     * @param PTYPE μζƨ
     */
    template <Ptype PTYPE>
    struct Escape : public TableProbabilityCategory
    {
      BOOST_STATIC_ASSERT(PtypeTraits<PTYPE>::isBasic);	// ȴ
      static Interpolator<PtypeValueTable> probTable;
      static const char *getName();
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue)
      {
	const Position from = move.from();
	const Player myself = move.player();
	const Player opponent = alt(myself);
	if ((unpromote(move.ptype()) == PTYPE)
	    && !from.isPieceStand() && env.state->hasEffectBy(opponent,from))
	{
	  const bool supported 
	    = env.state->hasEffectBy(myself, from);
	  const Piece attacker = 
	    EffectUtil::cheapestPiece(opponent, *env.state, from);
	  const size_t index = probTable.getIndex(supported,
						  attacker.ptype(),
						  pieceValue);
	  return std::make_pair(true,index);
	}
	return std::make_pair(false,0u);
      }
      static void generate(const CategoryEnv& env, MoveLogProbVector& out);
      static void generate(const CategoryEnv& env, MoveLogProbVector& out,
			   int *indices);
    };

    /**
     * ľζˤ attack 򤫤줿ư.
     * FIXME: 
     * - isInCategory ǤƨƤ뤫ɤϥåƤʤ
     * - ľι⤬狼ɤ֤ͤ򸫤ɾ٤
     */
    struct ImmediateEscape : public TableProbabilityCategory
    {
      static Interpolator<PtypePtypeProbTable> probTable;
      static const char *getName() { return "Escape!"; }
      static std::pair<bool,size_t> 
      getIndexIf(const CategoryEnv& env, Move move, int pieceValue)
      {
	const Move last_move=env.history->lastMove();
	if (! last_move.isNormal()) 
	  return std::make_pair(false,0u);
	if (move.from()==Position::STAND()) 
	  return std::make_pair(false,0u);
	if (env.state->hasEffectTo
	    (env.state->getPieceOnBoard(last_move.to()), move.from()))
	{
	  const bool supported 
	    = env.state->hasEffectBy(env.state->getTurn(), last_move.to());
	  const size_t index = 
	    probTable.getIndex(move.ptype(), supported,
			       last_move.ptype(), pieceValue);
	  return std::make_pair(true,index);
	}
	return std::make_pair(false,0u);
      }
      struct PositionAction;
      static void generate(const CategoryEnv& env, MoveLogProbVector& out);
      static void generate(const CategoryEnv& env, MoveLogProbVector& out,
			   int *indices);
    };


  } // namespace category
} // namespace osl

#endif /* _ESCAPE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
