/* ptypePosition.h
 */
#ifndef _PTYPEPOSITION_H
#define _PTYPEPOSITION_H

#include "osl/category/categoryEnv.h"
#include "osl/category/categoryTraits.h"
#include "osl/misc/carray.h"

namespace osl
{
  namespace category
  {
    struct PtypePositionTable : public ProbTable<32*256*256>
    {
      typedef ProbTable<32*256*256> base_t;
      PtypePositionTable(const char *h, const char *n)
	: base_t(h,n)
      {
      }
      static int getIndex(Move move)
      {
	PtypeO ptypeO=move.ptypeO();
	Position from=move.from();
	Position to=move.to();
	size_t index=(ptypeO-PTYPEO_MIN)*256*256+from.index()*256+to.index();
	return index;
      }
    };

    /**
     * ptypeo, from, to˴Ť¸Ψ
     */
    struct PtypePosition : public TableProbabilityCategory
    {
      static Interpolator<PtypePositionTable> probTable;
      static const char *getName() { return "PtypePosition"; }
      static const bool FirstMatchOnly = true;
      static size_t getIndex(const CategoryEnv&, Move m)
      {
	return PtypePositionTable::getIndex(m);
      }
      static std::pair<bool,size_t>
      getIndexIf(const CategoryEnv& e, Move m, int /*piece_value*/)
      {
	return std::make_pair(true, getIndex(e,m));
      }
      static bool isInCategory(const CategoryEnv&, Move) 
      {
	return true;
      }
    };
  } // namespace category
} // namespace osl

#endif /* _PTYPEPOSITION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
