/* checkTableAnalyzer.h
 */
#ifndef _CHECKTABLEANALYZER_H
#define _CHECKTABLEANALYZER_H

#include <iosfwd>
#include <cstddef>
namespace osl
{
  namespace hash
  {
    class HashKey;
  }
  class PathEncoding;
  namespace checkmate
  {
    class CheckHashRecord;
    class TwinTable;
    namespace analyzer
    {
      using hash::HashKey;
      /**
       * ;õΥơ֥ʬ
       *
       * õڤ礭ȡĤɬפڤ礭
       * (ǾڤȤϸ¤ʤ)
       * TODO: ɬפʻʤɤ
       */
      class CheckTableAnalyzer
      {
	const TwinTable& table;
	bool useOutlineFormat;
      public:
	explicit CheckTableAnalyzer(const TwinTable&, bool outline=true);
	~CheckTableAnalyzer();
    
	/**
	 * record  root Ȥڤ񤭽Ф
	 */
	void showTree(const CheckHashRecord *record, std::ostream& os,
		      int maxDepth, bool expandFinalState=true, 
		      bool showTerminalMoves=false, size_t threshold=0) const;
	/**
	 * ơ֥state ãǽʶ̤οĴ٤
	 */
	size_t treeSize(const CheckHashRecord *record) const;
	/**
	 * record ξΤɬפʶ̤οĴ٤
	 */
	size_t proofTreeSize(const CheckHashRecord *record, 
			     const HashKey& key, 
			     const PathEncoding& path, 
			     bool orNode) const;
	size_t proofTreeSize(const CheckHashRecord *record, 
			     const HashKey& key, 
			     const PathEncoding& path, 
			     bool orNode, size_t &leaf_size) const;
	/**
	 * record ȿڤΤɬפʶ̤οĴ٤
	 */
	size_t disproofTreeSize(const CheckHashRecord *record, 
				const HashKey& key, 
				const PathEncoding& path, 
				bool orNode, bool isPartialStack=false) const;
	size_t disproofTreeSize(const CheckHashRecord *record, 
				const HashKey& key, 
				const PathEncoding& path, 
				bool orNode, size_t& leaf_size, 
				bool isPartialStack=false) const;
	/**
	 * @return state  ͤߤǤԵͤǤʤ 0 
	 */
	size_t proofOrDisproofTreeSize(const CheckHashRecord *record, 
				       const HashKey& key, 
				       const PathEncoding& path, 
				       bool orNode, bool isPartialStack=false) const;
	size_t proofOrDisproofTreeSize(const CheckHashRecord *record, 
				       const HashKey& key, 
				       const PathEncoding& path,
				       bool orNode, size_t& leaf_size, 
				       bool isPartialStack=false) const;

	/**
	 * ơ֥state ξΤɬפڤɽ
	 */
	size_t showProofTree(const CheckHashRecord *record, 
			     const HashKey& key, const PathEncoding& path, 
			     bool orNode, std::ostream& os,
			     bool isPartialStack=false) const;
      };
    } // namespace analyzer
  } // namespace checkmate
  using checkmate::analyzer::CheckTableAnalyzer;
} // namespace osl

#endif /* _CHECKTABLEANALYZER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
