/* immediateCheckmate.h
 */
#ifndef _CHECKMATE_IMMEDIATE_CHECKMATE_H
#define _CHECKMATE_IMMEDIATE_CHECKMATE_H
#include "osl/checkmate/king8Info.h"
#include "osl/state/numEffectState.h"
#include "osl/move.h"

namespace osl
{
  namespace checkmate
  {
    class ImmediateCheckmate
    {
    private:
      template<Player P,bool setBestMove>
      static bool hasCheckmateDrop(NumEffectState const& state,Position target,
				   King8Info mask,Move& bestMove);

    public:
      template<Player P,bool setBestMove>
      static bool slowHasCheckmateMoveDirPiece(NumEffectState const& state,Position target,
					       King8Info mask,Direction d,Position pos,Piece p,Ptype ptype,Move& bestMove);

      template<Player P,bool setBestMove>
      static bool hasCheckmateMoveDirPiece(NumEffectState const& state,Position target,
					   King8Info mask,Direction d,Position pos,Piece p,Move& bestMove);

      template<Player P,bool setBestMove>
      static bool hasCheckmateMoveDir(NumEffectState const& state,Position target,
				      King8Info mask,Direction d,Move& bestMove);

      template<Player P,bool setBestMove>
      static bool hasCheckmateMove(NumEffectState const& state,Position target,
				   King8Info mask,Move& bestMove);

      /**
       * ͤ᤬̤ɤȽ(move).
       * ֤¦˲꤬äƤϽ
       * Ĺˤ벦ʤ
       * pinƤʤ˵ͤߤˤʤⰷʤ
       * @param P(template) - ¦(¦)Υץ쥤䡼
       * @param state - 
       */
      template<Player P>
      static bool hasCheckmateMove(NumEffectState const& state);
      template<Player P>
      static bool hasCheckmateMove(NumEffectState const& state, King8Info);

      /**
       * ͤ᤬̤ɤȽ(move).
       * ֤¦˲꤬äƤϽ
       * Ĺˤ벦ʤ
       * pinƤʤ˵ͤߤˤʤⰷʤ
       * @param P(template) - ¦(¦)Υץ쥤䡼
       * @param state - 
       * @param best_move - ˵ͤμ֤
       */
      template<Player P>
      static bool hasCheckmateMove(NumEffectState const& state,Move &bestMove);
      template<Player P>
      static bool hasCheckmateMove(NumEffectState const& state, 
				   King8Info canMoveMask,
				   Position king, Move& bestMove);
      /**
       *
       */
      static bool hasCheckmateMove(Player pl,NumEffectState const& state);
      static bool hasCheckmateMove(Player pl,NumEffectState const& state,Move& bestMove);

    };
  } // namespace checkmate
  using checkmate::ImmediateCheckmate;
} // namespace osl
#endif /* _CHECKMATE_IMMEDIATE_CHECKMATE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

