/* linearMoveMap.h
 */
#ifndef CONTAINER_LINEARMOVEMAP_H
#define CONTAINER_LINEARMOVEMAP_H

#include "osl/misc/carray.h"
#include "osl/stl/slist.h"
#include "osl/move.h"
#include <algorithm>
#include <cassert>

namespace osl
{
  namespace container
  {
  /**
   * Move  T map vector˵ͤ᤿Ρ
   */
  template <class T>
  class LinearMoveMap : private slist<T>
  {
  public:
    typedef slist<T> base_t;
    using base_t::swap;
    using base_t::clear;
    using base_t::begin;
    using base_t::end;
    using base_t::const_iterator;
    using base_t::iterator;
    using base_t::size;
    using base_t::empty;

    /**
     * ƱǤʤȤˡ˥ȥ
     * Ƥʤ map ȤƤþ
     */
    T* insertNoCheck(const T& element)
    {
      push_front(element);
      return &base_t::front();
    }
    /**
     * ƱǤо񤭤롤ʤп˺
     */
    T* assign(const T& element)
    {
      const Move m = element.getMove();
      T *p = find(m);
      if (p)
      {
	*p = element;
	return p;
      }
      return insertNoCheck(element);
    }
    T* find(Move key)
    {
      for (typename base_t::iterator p=begin(); p!=end(); ++p)
      {
	if (p->getMove() == key)
	  return &*p;
      }
      return 0;
    }
    const T* find(Move key) const
    {
      for (typename base_t::const_iterator p=begin(); p!=end(); ++p)
      {
	if (p->getMove() == key)
	  return &*p;
      }
      return 0;
    }
  };
} // namespace container
  using container::LinearMoveMap;
} // namespace osl


#endif /* _MOVEMAP_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
