/* additionalOrShadow.h
 */
#ifndef OSL_ADDITIONALORSHADOW_H
#define OSL_ADDITIONALORSHADOW_H

#include "osl/state/numEffectState.h"
#include "osl/boardTable.h"
#include "osl/container/pieceVector.h"

namespace osl
{
  namespace effect_util
  {
    struct AdditionalOrShadow
    {
      template <int count_max>
      static int count(const PieceVector& direct_pieces, 
		       const NumEffectState& state,
		       Position target, Player attack)
      {
	int result=0;
	for (PieceVector::const_iterator p=direct_pieces.begin();
	     p!=direct_pieces.end(); ++p)
	{
	  const Position from = p->position();
	  const Offset32 diff32 = Offset32(from, target);
	  const Offset step = Board_Table.getShortOffsetNotKnight(diff32);
	  if (step.zero())
	    continue;
	  // 8ξ
	  Piece candidate=state.nextPiece(from, step);
	  for (; candidate.isPiece() && (candidate.owner() == attack); 
	       candidate=state.nextPiece(candidate.position(), step))
	  {

	    const Offset32 diff_reverse = Offset32(target,candidate.position());
	    const EffectContent effect 
	      = Ptype_Table.getEffect(candidate.ptypeO(), diff_reverse);
	    if (! effect.hasEffect())
	      break;
	    ++result;
	    if (result >= count_max)
	      return result;
	  }
	}
	return result;
      }

    };
  }
} // namespace osl

#endif /* OSL_ADDITIONALORSHADOW_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
