#ifndef _EFFECTUTIL_H
#define _EFFECTUTIL_H

#include "osl/state/numEffectState.h"
#include "osl/misc/carray.h"
#include "osl/container/pieceVector.h"

#include <iosfwd>
#include <cassert>

namespace osl
{
  namespace state
  {
    class SimpleState;
  }
  namespace container
  {
    class PieceVector;
  }

  namespace effect_util
  {
    using state::SimpleState;
  /**
   * EffectState Ѥ뤿Υ᥽å
   * NumSimpleEffect ʤɤθ󥿡ե
   * Ȥäƽ񤱤륳
   */
  struct EffectUtil
  {
    /**
     * effectTarget ΤäȤ¤õ
     * @return ޤϡ̵ Piece::EMPTY() ֤
     * @param P õоݤζνͭ
     * @param effectTarget on board Ǥ뤳
     */
    template <class EffectState>
    static Piece cheapestPiece(Player P, const EffectState&, 
			       Position effectTarget);
    /**
     * pos Τ promote ǽ ptype Ķõ
     * pos  promote ǽʥޥɤϸʤ
     * @return ޤϡ̵ Piece::EMPTY() ֤
     * @param P õоݤζνͭ
     * @param effectTarget on board Ǥ뤳
     */
    template <class EffectState>
    static Piece promotablePiece(Player P, const EffectState&, 
				 Position effectTarget);


    /** 
     * Player P βŨ뤫ɤĴ٤
     */
    template <class EffectState>
    static bool isKingInCheck(Player P, const EffectState& state)
    {
      const Position king_position=state.getKingPosition(P);
      // ;Ǥϼ̤ʤȤ⤢롥
      if (king_position.isPieceStand()) 
	return false;
      return state.hasEffectBy(alt(P), king_position);
    }
    /** 
     * Player P βΤŨζĴ٤
     * @return ̵ Piece::EMPTY() ֤
     */
    template <class EffectState>
    static Piece kingAttackPiece(Player P, const EffectState& state)
    {
      const Position king_position = state.getKingPosition(P);
      // ;Ǥϼ̤ʤȤ⤢롥
      if (king_position.isPieceStand()) 
	return Piece::EMPTY();
      return state.hasEffectPiece(alt(P), king_position);
    }
    /** 
     * target ˤɽ
     */
    template <class EffectState>
    static void showEffect(const EffectState& state, Position target,
			   std::ostream&);

    /**
     * PtypeO  Position ˤȲꤷˤ.
     * ̤ºݤȰ㤦ĹΤˤʤ
     * @param InterestEmpty Υޥ˶̣뤫
     */
    template <class State, class Function, bool InterestEmpty>
    static void forEachEffectOfPtypeO(const State& state, Position, PtypeO,
				      Function& f);
    template <Player P, class State, class Function, bool InterestEmpty>
    static void forEachEffectOfPtypeO(const State& state, Position, Ptype,
				      Function& f);
    /**
     * Move m ؤ(open ) Position  f Ϥ.
     * ĹϼʬưαƤ˼⤵Τ˻ߤޤ
     * @param InterestEmpty Υޥ˶̣뤫
     */
    template <class State, class Function, bool InterestEmpty>
    static void forEachEffectOfMove(const State& state, Move m, Function& f);
    template <class State, class Function>
    static void forEachEffectPositionOfMove(const State& state, Move m, Function& f)
    {
      forEachEffectOfMove<State,Function,true>(state, m, f);
    }
    template <class State, class Function>
    static void forEachEffectPieceOfMove(const State& state, Move m, Function& f)
    {
      forEachEffectOfMove<State,Function,false>(state, m, f);
    }
    
    /**
     * Move m ؤΡPlayer target ζؤ(open )
     * Ĵ٤(KING ʳ)Ǥͤι⤤֤
     * ̵ Piece::EMPTY() ֤
     */
    static Piece mostValuableEffectOfMoveNotKing(Player target, 
						 const SimpleState& state, Move m);

    /**
     * Move m ؤΡPlayer target ζؤ(open )
     * Ĵ٤(KING ʳ)Ǥͤι⤤֤
     * ̵ Piece::EMPTY() ֤
     */
    static void mostValuableEffectOfMoveNotKing(Player target, 
						const SimpleState& state, 
						Move m, CArray<Piece,2>& out);

    /**
     * ̤ȴʤ˹ˡtarget˰ưǽȽ
     * @param king  (̤ǼϹͤʤ)
     * @return ưǽʶ𤬤Сʶġʤ Piece::EMPTY()
     * @see osl::move_classifier::PawnDropCheckmate
     */
    template <Player P, class EffectState>
    static Piece safeCaptureNotByKing(const EffectState& state, Position target,
				    Piece king);
    template <class EffectState>
    static Piece safeCaptureNotByKing(Player P, const EffectState& state, 
				      Position target)
    {
      const Piece king = state.getKingPiece(P);
      if (P == BLACK)
	return safeCaptureNotByKing<BLACK,EffectState>(state, target, king);
      else
	return safeCaptureNotByKing<WHITE,EffectState>(state, target, king);
    }

    /**
     * forEachEffect  Player template ̾ΰˤС
     * @param P õоݤζνͭ
     * @param pos Τõ
     */
    template <class EffectState, class Action>
    static void forEachEffect(Player P, const EffectState& state, Position pos, 
			      Action& a)
    {
      if (P == BLACK)
	state.template forEachEffect<BLACK>(pos,a);
      else
	state.template forEachEffect<WHITE>(pos,a);
    }
    /**
     * target ΤPieceout˳Ǽ
     */
    template <class EffectState>
    static void findEffect(Player P, const EffectState& state, Position target,
			   container::PieceVector& out);
    /**
     * frommoveؤmoveؤOpen AttackˤʤäƤ뤫.
     * @param P(template) - moveμΤǤꡤμΤǤץ쥤.
     * @param state - ưξ
     * @param target - Ĵ٤׾ξ
     * @param from - ưζ
     * @param to - ưζ
     */
    template<Player P>
    static bool isOpenAttackMove(const SimpleState& state, Position target, Position from, Position to);
    /**
     * moveؤ䤹ɤ.
     * @param P(template) - moveμΤǤꡤμΤǤץ쥤.
     * @param state - ưξ
     * @param target - Ĵ٤׾ξ
     * @param move - stateǤPˤˡ
     * ĹϼʬưαƤ˼⤵Τ˻ߤޤ뤬
     * ξϸäʤΤɤȤ롥
     */
    template<Player P>
    static bool isAddEffectMove(const SimpleState& state, Position target,Move move);

    /**
     * state  position  ptypeo äꤷơҤout˽
     */
    static void findThreat(const NumEffectState& state, Position position,
			   PtypeO ptypeo, PieceVector& out);

    class SelectMostValuable;
    class FindThreat;
    template <int N> class SelectMostValuableN;
    template <class EffectState> class SafeCapture;
  };

  } // namespace effect_util
  using effect_util::EffectUtil;
} // namespace osl

#endif /* _EFFECTUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
