/* pieceEval.tcc
 */
#ifndef _PIECEEVAL_TCC
#define _PIECEEVAL_TCC
#include "osl/effect_action/storePtypeOPosition.h"
#include "osl/move_classifier/kingOpenMove.h"
#include "osl/eval/pieceEval.h"
#include "osl/container/pieceVector.h"
#include "osl/apply_move/applyMove.h"
namespace osl 
{
  namespace eval
  {
    using container::PtypeOPositionVector;
  /**
   * ʻؼ.
   * ñȴϹθ뤬ΤǤϤʤ
   * @param P ؼؤץ쥤
   */
  template <Player P>
  struct SelectSafePieces
  {
    template <class State>
    static void select(const State& state, Position target,
		       const PtypeOPositionVector& src,
		       PtypeOPositionVector& out)
    {
      for (size_t i=0; i<src.size(); ++i)
      {
	assert(P == getOwner(src[i].first));
	const Ptype ptype = getPtype(src[i].first);
	const Position from = src[i].second;
	if ((ptype == KING)	// ̵ǤƤ
	    || (! move_classifier::KingOpenMove<P>::
		isMember(state,ptype,from,target)))
	{
	  out.push_back(src[i]);
	}
      }
    }
    /**
     * @param exceptFor Ͻ
     */
    template <class State>
    static void select(const State& state, Position target,
		       const PtypeOPositionVector& src,
		       PtypeOPositionVector& out, Position except_for)
    {
      for (size_t i=0; i<src.size(); ++i)
      {
	assert(P == getOwner(src[i].first));
	const Ptype ptype = getPtype(src[i].first);
	const Position from = src[i].second;
	if ((ptype == KING)	// ̵ǤƤ
	    || (! move_classifier::KingOpenMove<P>::
		isMember(state,ptype,from,target,except_for)))
	{
	  out.push_back(src[i]);
	}
      }
    }
  };
  
  struct TakeBackValue
  {
    /** effectTo Τƽ */
    template <class State, Player P>
    static void findEffectPieces(const State& state, Position effect_to,
				 PtypeOPositionVector& my_pieces, 
				 PtypeOPositionVector& op_pieces)
    {
      typedef effect_action::StorePtypeOPosition store_t;
      store_t op_pieces_store(&op_pieces, effect_to);
      state.template forEachEffect<PlayerTraits<P>::opponent,store_t>
	(effect_to, op_pieces_store);
      if (! op_pieces.empty())
      {
	store_t my_pieces_store(&my_pieces, effect_to);
	state.template forEachEffect<P,store_t>(effect_to, my_pieces_store);
      }
    }
    /** move  move.to() Τƽ */
    template <class State, Player P>
    static void findEffectPiecesAfterMove(const State& state, Move move, 
					  PtypeOPositionVector& my_pieces, 
					  PtypeOPositionVector& op_pieces)
    {
      using namespace effect_action;
      
      const Position from=move.from();
      const Position to=move.to();
      const Player Opponent = PlayerTraits<P>::opponent;
      StorePtypeOPosition my_pieces_store(&my_pieces, to);
      StorePtypeOPosition op_pieces_store(&op_pieces, to);
      {
	// moveηŪΥޥѤΤĴ
	/** ʬ effectμˤäƤϹ®˵ޤ뤫⤷ʤ */
	/** offsetshort */
	/** knight move0ˤBoard_TableˤбΤϤʤ */
	Offset shortOffset=Board_Table.getShortOffsetNotKnight(Offset32(to,from));
	// knightξѤʤ
	if (! shortOffset.zero()){
	  Piece p;
	  for (Position pos=from-shortOffset; (p=state.getPieceAt(pos)).isEmpty();
	       pos-=shortOffset)
	    ;
	  if (p.isOnBoardByOwner<P>()){
	    // 
	    const int moveMask=Ptype_Table.getMoveMask(p.ptype());
	    Direction dir=Board_Table.getLongDirection<P>(Offset32(to,from));
	    if ((moveMask&dirToMask(dir))!=0){
	      my_pieces_store.store(p);
	    }
	  }
	  else if (p.isOnBoardByOwner<Opponent>()){
	    // 
	    const int moveMask=Ptype_Table.getMoveMask(p.ptype());
	    Direction dir=Board_Table.getLongDirection<P>(Offset32(from,to));
	    if ((moveMask&dirToMask(dir))!=0){
	      op_pieces_store.store(p);
	    }
	  }
	}
      }
      state.template forEachEffect<PlayerTraits<P>::opponent,StorePtypeOPosition>
	(to, op_pieces_store);
      if (! op_pieces.empty())
      {
	const Piece movePiece=state.getPieceAt(from);
	state.template forEachEffectNotBy<P,StorePtypeOPosition>
	  (to, movePiece,my_pieces_store);
      }
    }
    
    /**
     * PtypeOPositionVector Ȥ˼֤ͤ׻
     * 
     * FIXME: Фɤ PtypeOPositionVector  
     * PtypeO,Position Υ٥ѹɬפ롥 
     * computeDiffAfterMoveMulti ʤɤǶưˡ
     * move μ礤ͤƤˡpiece.position() ɬ
     * 礤Τposition ǤϤʤᡥ
     *
     * @param P alt(P) μ֤
     * @param target ˴ؤ֤
     * @param ptypeo target ˤꤵ
     */
    template <Player P>
    static int computeValue(Position target, PtypeO ptypeO, 
			    const PtypeOPositionVector& my_pieces, 
			    const PtypeOPositionVector& op_pieces)
    {
      int val = 0;
      CArray<int,Piece::SIZE> vals;
      const Player Opponent = PlayerTraits<P>::opponent;
      size_t i;
      for (i=0;i<op_pieces.size();i++)
      {
	vals[i*2]=val;
	// opponentMove
	val+=Ptype_Eval_Table.captureValue(ptypeO);
	{
	  ptypeO = op_pieces[i].first;
	  const bool promotable = canPromote(ptypeO) 
	    && (target.canPromote<Opponent>() 
		|| op_pieces[i].second.canPromote<Opponent>());
	  if (promotable)
	  {
	    ptypeO=promote(ptypeO);
	    val+=Ptype_Eval_Table.promoteValue(ptypeO);
	  }
	}
	vals[i*2+1]=val;
	// myMove
	if (i>=my_pieces.size()){
	  break;
	}
	val+=Ptype_Eval_Table.captureValue(ptypeO);
	{
	  ptypeO=my_pieces[i].first;
	  const bool promotable = canPromote(ptypeO) 
	    && (target.canPromote<P>() 
		|| my_pieces[i].second.canPromote<P>());
	  if (promotable)
	  {
	    ptypeO=promote(ptypeO);
	    val+=Ptype_Eval_Table.promoteValue(ptypeO);
	  }
	}
      }
      for (int j=i-1;j>=0;j--)
      {
	val=EvalTraits<P>::max(val,vals[j*2+1]);
	val=EvalTraits<Opponent>::max(val,vals[j*2]);
      }
      return val;
    }
  };

  /** P  PTYPE ζä */
  template <Ptype PTYPE> inline int captureVal(Player P)
  {
    // unpromote(PTYPE) ǵ¨ͤ˽
    return Ptype_Eval_Table.captureValue(newPtypeO(alt(P),PTYPE));
  }
} // namespace eval
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::
computeDiffAfterTakeBackLimited(const State& state, Position focus)
{
  const Piece target = state.getPieceOnBoard(focus);
  assert(target.isPiece());
  assert(P == target.owner());

  PtypeOPositionVector my_pieces,op_pieces;
  TakeBackValue::findEffectPieces<State,P>(state, focus, 
					   my_pieces, op_pieces);

  if (op_pieces.empty())
    return 0;

  PtypeOPositionVector my_safe_pieces, op_safe_pieces;
  SelectSafePieces<P>::
    select(state, focus, my_pieces, my_safe_pieces);
  SelectSafePieces<PlayerTraits<P>::opponent>::
    select(state, focus, op_pieces, op_safe_pieces);
  
  my_safe_pieces.sort();
  op_safe_pieces.sort();

  return TakeBackValue::computeValue<P>(focus, target.ptypeO(), 
					my_safe_pieces, op_safe_pieces);
}

template<class State, osl::Player P>
int osl::PieceEval::
computeDiffAfterMove(const State& state, Move move)
{
  assert(P == state.getTurn());
  assert(state.isAlmostValidMove(move));

  /** move.to() Τ򽸤 */
  PtypeOPositionVector my_pieces,op_pieces;
  /**
   * moveη, Ӥ뤫
   */ 
  const Position from=move.from();
  const Position to=move.to();
  int val=0; 
  /**
   * Ǽʬ٤Ƥζ
   */
  if (from.isPieceStand()) // drop moveϴñ
  {
    TakeBackValue::findEffectPieces<State,P>(state, to, 
					     my_pieces, op_pieces);
  }
  else
  {
    val+=diffWithMove(state,move);
    TakeBackValue::
      findEffectPiecesAfterMove<State,P>(state, move, my_pieces, op_pieces);
  }

  if (op_pieces.empty())
    return val;

  PtypeOPositionVector my_safe_pieces, op_safe_pieces;
  if (from.isPieceStand())
  {
    SelectSafePieces<P>::
      select(state, to, my_pieces, my_safe_pieces);
    SelectSafePieces<PlayerTraits<P>::opponent>::
      select(state, to, op_pieces, op_safe_pieces);
  }
  else
  {
    SelectSafePieces<P>::
      select(state, to, my_pieces, my_safe_pieces, from);
    SelectSafePieces<PlayerTraits<P>::opponent>::
      select(state, to, op_pieces, op_safe_pieces, from);
  }
  
  my_safe_pieces.sort();
  op_safe_pieces.sort();

  return val + TakeBackValue::
    computeValue<P>(to, move.ptypeO(), my_safe_pieces, op_safe_pieces);
}

namespace osl
{
namespace eval
{
  /**
   * ؼμ֤ͤɾ
   * P ζõƤǤμ礤
   * alt(P) λɤʤ result 򹹿롥
   */
  template <class State,Player P>
  struct UpdateTakeBackAfterMove
  {
    const State& state;
    int& best_value;
    const Position move_to, move_from;
    const Piece captured;
    const PtypeO moved_type;
    UpdateTakeBackAfterMove(const State& s, Move m, int &v) 
      : state(s), best_value(v), move_to(m.to()), move_from(m.from()),
	captured(s.getPieceAt(move_to)), moved_type(m.ptypeO())
    {
    }
    void operator()(Piece targetPiece)
    {
      using namespace effect_action;
      
      if (targetPiece.position() == move_from)	// ư
	return;
      const Position target = targetPiece.position();
      PtypeOPositionVector my_pieces, op_pieces;
      StorePtypeOPosition my_pieces_store(&my_pieces, target), 
	op_pieces_store(&op_pieces, target);

      if (captured.isPiece())
	state.template forEachEffectNotBy<PlayerTraits<P>::opponent,StorePtypeOPosition>
	  (target, captured, op_pieces_store);
      else
	state.template forEachEffect<PlayerTraits<P>::opponent,StorePtypeOPosition>
	  (target, op_pieces_store);

      if (op_pieces.empty())
	return;

      if (move_from.isPieceStand())
	state.template forEachEffect<P,StorePtypeOPosition>
	  (target, my_pieces_store);
      else
	state.template forEachEffectNotBy<P,StorePtypeOPosition>
	  (target, state.getPieceAt(move_from), my_pieces_store);

      if (state.hasEffectFromTo(moved_type, move_to, target))
      {
	my_pieces.push_back(std::make_pair(moved_type, move_to));
      }
      // CAVEAT: ưȡȴη׻ѹɬפ
      PtypeOPositionVector my_safe_pieces, op_safe_pieces;
      SelectSafePieces<P>::
	select(state, target, my_pieces, my_safe_pieces);
      SelectSafePieces<PlayerTraits<P>::opponent>::
	select(state, target, op_pieces, op_safe_pieces);
  
      my_safe_pieces.sort();
      op_safe_pieces.sort();

      const int cur
	= TakeBackValue::computeValue<P>
	(target, targetPiece.ptypeO(), my_safe_pieces, op_safe_pieces);

      if (EvalTraits<PlayerTraits<P>::opponent>::betterThan(cur, best_value))
	best_value = cur;
    }
  };
} // namespace eval
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::computeDiffAfterMoveMulti(const State& state,Move move)
{
  assert(P == state.getTurn());
  assert(P == move.player());
  assert(state.isAlmostValidMove(move));

  const Player Opp = PlayerTraits<P>::opponent;
  int best_value = computeDiffAfterMove<State,P>(state, move);
  // computeDiffAfterMove 2ƤǤ̵̤ɤνʣ򤱤
  const int direct_diff = diffWithMove(state,move);
  best_value -= direct_diff;
  
  // դ if ʬư promotion ΤǤʤ
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<PROOK>(Opp)))
    return best_value+direct_diff;
  typedef UpdateTakeBackAfterMove<State,P> updator_t;
  updator_t updator(state, move, best_value);
  state.template forEachOnBoard<P,ROOK,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<PBISHOP>(Opp)))
    return best_value+direct_diff;
  state.template forEachOnBoard<P,BISHOP,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<GOLD>(Opp)))
    return best_value+direct_diff;
  state.template forEachOnBoard<P,GOLD,updator_t>(updator);
  // ä϶Ʊ  ɤøʤΤǻ޴ͥ
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<SILVER>(Opp)))
    return best_value+direct_diff;
  state.template forEachOnBoard<P,SILVER,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<KNIGHT>(Opp)))
    return best_value+direct_diff;
  state.template forEachOnBoard<P,KNIGHT,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<LANCE>(Opp)))
    return best_value+direct_diff;
  state.template forEachOnBoard<P,LANCE,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<PAWN>(Opp)))
    return best_value+direct_diff;
  state.template forEachOnBoard<P,PAWN,updator_t>(updator);
  return best_value+direct_diff;
}

namespace osl
{
namespace eval
{
  /**
   * P ζõƤǤμ礤
   * alt(P) λɤʤ result 򹹿롥
   */
  template <class State,Player P>
  struct UpdateTakeBack
  {
    const State& state;
    int& best_value;
    UpdateTakeBack(const State& s, int &v) 
      : state(s), best_value(v)
    {
    }
    void operator()(Piece target)
    {
      const int cur = PieceEval::
	computeDiffAfterTakeBackLimited<State,P>(state, target.position());

      if (EvalTraits<PlayerTraits<P>::opponent>::betterThan(cur, best_value))
	best_value = cur;
    }
  };
} // namespace eval
} // namespace osl

template<class State, osl::Player P>
int osl::eval::PieceEval::computeDiffAfterTakeBackMulti(const State& state)
{
  const Player Opp = PlayerTraits<P>::opponent;
  int best_value = 0;
  
  // դ if ʬư promotion ΤǤʤ
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<PROOK>(Opp)))
    return best_value;
  typedef UpdateTakeBack<State,P> updator_t;
  updator_t updator(state, best_value);
  state.template forEachOnBoard<P,ROOK,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<PBISHOP>(Opp)))
    return best_value;
  state.template forEachOnBoard<P,BISHOP,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<GOLD>(Opp)))
    return best_value;
  state.template forEachOnBoard<P,GOLD,updator_t>(updator);
  // ä϶Ʊ  ɤøʤΤǻ޴ͥ
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<SILVER>(Opp)))
    return best_value;
  state.template forEachOnBoard<P,SILVER,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<KNIGHT>(Opp)))
    return best_value;
  state.template forEachOnBoard<P,KNIGHT,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<LANCE>(Opp)))
    return best_value;
  state.template forEachOnBoard<P,LANCE,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(best_value, captureVal<PAWN>(Opp)))
    return best_value;
  state.template forEachOnBoard<P,PAWN,updator_t>(updator);
  return best_value;
} 

#endif /* _PIECEEVAL_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
