/* winCountTracer.h
 */
#ifndef GAME_PLAYING_WEIGHTTRACER_H
#define GAME_PLAYING_WEIGHTTRACER_H

#include "osl/game_playing/openingBookTracer.h"
#include "osl/stl/stack.h"

namespace osl
{
  namespace record
  {
    namespace opening
    {
      class WeightedBook;
    }
  }
  namespace game_playing
  {
    /**
     * WeightedBook
     */
    class WeightTracer : public OpeningBookTracer
    {
    public:
      typedef record::opening::WeightedBook WeightedBook;
    private:
      WeightedBook& book;
      int state_index, start_index;
      Player turn;
      bool verbose;
      osl::stack<int> state_stack;
    public:
      explicit WeightTracer(WeightedBook&, bool verbose=false);
      WeightTracer(const WeightTracer&);
      OpeningBookTracer* clone() const;

      void update(Move);
      const Move selectMove() const;

      int stateIndex() const { return state_index; }
      bool isOutOfBook() const;
      void popMove();
    };
  } // namespace game_playing
} // namespace osl

#endif // GAME_PLAYING_WEIGHTTRACER_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
