/* bishopMobility.h
 */
#ifndef MOBILITY_BISHOP_MOBILITY_H
#define MOBILITY_BISHOP_MOBILITY_H
#include "osl/mobility/countMobility.h"

namespace osl
{
  namespace mobility
  {
    /**
     * ׾γѤϤưޥο
     */
    struct BishopMobility
    {
    public:
      /**
       * Ф
       * P : pλ
       * countAll : ˴طʤưޥ
       * countSafe : ʤưޥ
       * ξ
       */
      template<Player P>
      static void countBoth(const NumEffectState& state,Piece p,int& countAll,int& countSafe){
	assert(p.ptype()==BISHOP || p.ptype()==PBISHOP);
	assert(p.isOnBoard());
	assert(p.owner()==P);
	const Position pos=p.position();
	countMobilityBoth<P,true,true>(state,pos,DirectionPlayerTraits<UL,P>::offset(),countAll,countSafe);
	countMobilityBoth<P,true,true>(state,pos,DirectionPlayerTraits<UR,P>::offset(),countAll,countSafe);
	countMobilityBoth<P,true,true>(state,pos,DirectionPlayerTraits<DL,P>::offset(),countAll,countSafe);
	countMobilityBoth<P,true,true>(state,pos,DirectionPlayerTraits<DR,P>::offset(),countAll,countSafe);
      }
      static void countBoth(Player pl,const NumEffectState& state,Piece p,int& countAll,int& countSafe){
	if(pl==BLACK)
	  countBoth<BLACK>(state,p,countAll,countSafe);
	else
	  countBoth<WHITE>(state,p,countAll,countSafe);
      }
      /**
       * Ф˴طʤưޥο
       */
      template<Player P>
      static int countAll(const NumEffectState& state,Piece p){
	assert(p.ptype()==BISHOP || p.ptype()==PBISHOP);
	assert(p.isOnBoard());
	assert(p.owner()==P);
	const Position pos=p.position();
	return 
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<UL,P>::offset())+
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<UR,P>::offset())+
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<DL,P>::offset())+
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<DR,P>::offset());
      }
      static int countAll(Player pl,const NumEffectState& state,Piece p){
	if(pl==BLACK)
	  return countAll<BLACK>(state,p);
	else
	  return countAll<WHITE>(state,p);
      }
      /**
       * Фʤưޥ
       */
      template<Player P>
      static int countSafe(const NumEffectState& state,Piece p){
	assert(p.ptype()==BISHOP || p.ptype()==PBISHOP);
	assert(p.isOnBoard());
	assert(p.owner()==P);
	const Position pos=p.position();
	return 
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<UL,P>::offset())+
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<UR,P>::offset())+
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<DL,P>::offset())+
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<DR,P>::offset());
      }
      static int countSafe(Player pl,const NumEffectState& state,Piece p){
	if(pl==BLACK)
	  return countSafe<BLACK>(state,p);
	else
	  return countSafe<WHITE>(state,p);
      }
    };
  }
}
#endif /* MOBILITY_BISHOP_MOBILITY_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
