/* rookMobility.h
 */
#ifndef MOBILITY_ROOK_MOBILITY_H
#define MOBILITY_ROOK_MOBILITY_H
#include "osl/mobility/countMobility.h"

namespace osl
{
  namespace mobility
  {
    /**
     * ׾֤εưޥ
     */
    struct RookMobility
    {
    public:
      /**
       * 
       * P : pλ
       * countAll : ˴طʤưޥ
       * countSafe : ʤưޥ
       * ξ
       */
      template<Player P>
      static void countVerticalBoth(const NumEffectState& state,Piece p,int& countAll,int& countSafe){
	assert(p.ptype()==ROOK || p.ptype()==PROOK);
	assert(p.isOnBoard());
	assert(p.owner()==P);
	const Position pos=p.position();
	countMobilityBoth(P,state,pos,DirectionPlayerTraits<U,P>::offset(),countAll,countSafe);
	countMobilityBoth(P,state,pos,DirectionPlayerTraits<D,P>::offset(),countAll,countSafe);
      }
      static void countVerticalBoth(Player pl,const NumEffectState& state,Piece p,int& countAll,int& countSafe){
	if(pl==BLACK)
	  countVerticalBoth<BLACK>(state,p,countAll,countSafe);
	else
	  countVerticalBoth<WHITE>(state,p,countAll,countSafe);
      }
      /**
       * ˴طʤưޥο
       */
      template<Player P>
      static int countVerticalAll(const NumEffectState& state,Piece p){
	const Position pos=p.position();
	return 
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<U,P>::offset())+
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<D,P>::offset());
      }
      static int countVerticalAll(Player pl,const NumEffectState& state,Piece p){
	if(pl==BLACK)
	  return countVerticalAll<BLACK>(state,p);
	else
	  return countVerticalAll<WHITE>(state,p);
      }
      /**
       * ʤưޥ
       */
      template<Player P>
      static int countVerticalSafe(const NumEffectState& state,Piece p){
	const Position pos=p.position();
	return 
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<U,P>::offset())+
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<D,P>::offset());
      }
      static int countVerticalSafe(Player pl,const NumEffectState& state,Piece p){
	if(pl==BLACK)
	  return countVerticalSafe<BLACK>(state,p);
	else
	  return countVerticalSafe<WHITE>(state,p);
      }
      /**
       * 
       * P : pλ
       * countAll : ˴طʤưޥ
       * countSafe : ʤưޥ
       * ξ
       */
      template<Player P>
      static void countHorizontalBoth(const NumEffectState& state,Piece p,int& countAll,int& countSafe){
	assert(p.ptype()==ROOK || p.ptype()==PROOK);
	assert(p.isOnBoard());
	assert(p.owner()==P);
	const Position pos=p.position();
	countMobilityBoth(P,state,pos,DirectionPlayerTraits<L,P>::offset(),countAll,countSafe);
	countMobilityBoth(P,state,pos,DirectionPlayerTraits<R,P>::offset(),countAll,countSafe);
      }
      static void countHorizontalBoth(Player pl,const NumEffectState& state,Piece p,int& countAll,int& countSafe){
	if(pl==BLACK)
	  countHorizontalBoth<BLACK>(state,p,countAll,countSafe);
	else
	  countHorizontalBoth<WHITE>(state,p,countAll,countSafe);
      }
      /**
       * ˴طʤưޥο
       */
      template<Player P>
      static int countHorizontalAll(const NumEffectState& state,Piece p){
	const Position pos=p.position();
	return 
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<L,P>::offset())+
	  countMobilityAll(P,state,pos,DirectionPlayerTraits<R,P>::offset());
      }
      static int countHorizontalAll(Player pl,const NumEffectState& state,Piece p){
	if(pl==BLACK)
	  return countHorizontalAll<BLACK>(state,p);
	else
	  return countHorizontalAll<WHITE>(state,p);
      }
      /**
       * ʤưޥ
       */
      template<Player P>
      static int countHorizontalSafe(const NumEffectState& state,Piece p){
	const Position pos=p.position();
	return 
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<L,P>::offset())+
	  countMobilitySafe(P,state,pos,DirectionPlayerTraits<R,P>::offset());
      }
      static int countHorizontalSafe(Player pl,const NumEffectState& state,Piece p){
	if(pl==BLACK)
	  return countHorizontalSafe<BLACK>(state,p);
	else
	  return countHorizontalSafe<WHITE>(state,p);
      }
    };
  }
}
#endif /* MOBILITY_ROOK_MOBILITY_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
