/* toAroundKing24Filter.h
 */
#ifndef _MOVE_TO_AROUND_KING24_FILTER_H
#define _MOVE_TO_AROUND_KING24_FILTER_H
#include "osl/position.h"
#include "osl/player.h"
#include "osl/ptype.h"
#include "osl/move_action/concept.h"
#include "osl/move_classifier/kingOpenMove.h"

namespace osl
{
  namespace move_action
  {
    
    /**
     * ̤ 24˵ؤμ
     */
    template<Player P,class State,class OrigAction>
    struct ToAroundKing24Filter
    {
      BOOST_CLASS_REQUIRE(OrigAction,osl::move_action,Concept);
      const State& state;
      OrigAction & action;
      Position position_king;

    public:
      ToAroundKing24Filter(const State& s, OrigAction & action)
	:
	state(s), action(action), position_king(s.template getKingPosition<P>())
      {
      }

      bool isToAroundKing24Move(Position to)
      {
	//׻®! by Yoshiki
	return to + Board_Table.getOffsetForBlack(UL)== position_king ||
	  to + Board_Table.getOffsetForBlack(U)== position_king ||
	  to + Board_Table.getOffsetForBlack(UR)== position_king ||
	  to + Board_Table.getOffsetForBlack(L)== position_king ||
	  to + Board_Table.getOffsetForBlack(R)== position_king ||
	  to + Board_Table.getOffsetForBlack(DL)== position_king ||
	  to + Board_Table.getOffsetForBlack(D)== position_king ||
	  to + Board_Table.getOffsetForBlack(DR)== position_king ||
	  to + Board_Table.getOffsetForBlack(UL)
	  + Board_Table.getOffsetForBlack(UL) == position_king ||
	  to + Board_Table.getOffsetForBlack(UL)
	  + Board_Table.getOffsetForBlack(U) == position_king ||
	  to + Board_Table.getOffsetForBlack(U)
	  + Board_Table.getOffsetForBlack(U) == position_king ||
	  to + Board_Table.getOffsetForBlack(UR)
	  + Board_Table.getOffsetForBlack(U) == position_king ||
	  to + Board_Table.getOffsetForBlack(UR)
	  + Board_Table.getOffsetForBlack(UR) == position_king ||
	  to + Board_Table.getOffsetForBlack(UL)
	  + Board_Table.getOffsetForBlack(L) == position_king ||
	  to + Board_Table.getOffsetForBlack(UR)
	  + Board_Table.getOffsetForBlack(R) == position_king ||
	  to + Board_Table.getOffsetForBlack(L)
	  + Board_Table.getOffsetForBlack(L) == position_king ||
	  to + Board_Table.getOffsetForBlack(R)
	  + Board_Table.getOffsetForBlack(R) == position_king ||
	  to + Board_Table.getOffsetForBlack(DL)
	  + Board_Table.getOffsetForBlack(L) == position_king ||
	  to + Board_Table.getOffsetForBlack(DR)
	  + Board_Table.getOffsetForBlack(R) == position_king ||
	  to + Board_Table.getOffsetForBlack(DL)
	  + Board_Table.getOffsetForBlack(DL) == position_king ||
	  to + Board_Table.getOffsetForBlack(DL)
	  + Board_Table.getOffsetForBlack(D) == position_king ||
	  to + Board_Table.getOffsetForBlack(D)
	  + Board_Table.getOffsetForBlack(D) == position_king ||
	  to + Board_Table.getOffsetForBlack(DR)
	  + Board_Table.getOffsetForBlack(R) == position_king ||
	  to + Board_Table.getOffsetForBlack(DR)
	  + Board_Table.getOffsetForBlack(DR) == position_king ||
	  ;
      }
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	assert(p == P);
	if(isToAroundKing24Move(to))
	  action.simpleMove(from,to,ptype,isPromote,P);
      
      }
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	assert(p == P);
	if(isToAroundKing24Move(to))
	  action.unknownMove(from,to,p1,ptype,isPromote,P);
      }
      void dropMove(Position to,Ptype ptype,Player p){
	assert(p == P);
	if(isToAroundKing24Move(to))
	  action.dropMove(to,ptype,P);
      }
    };
  } // namespace move_action
} // namespace osl

#endif /* _MOVE_TO_AROUND_KING24_FILTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
