/* toAroundKing8Filte.h
 */
#ifndef _MOVE_TO_AROUND_KING8_FILTER_H
#define _MOVE_TO_AROUND_KING8_FILTER_H
#include "osl/position.h"
#include "osl/player.h"
#include "osl/ptype.h"
#include "osl/move_action/concept.h"
#include "osl/move_classifier/kingOpenMove.h"
#include "osl/centering3x3.h"

namespace osl
{
  namespace move_action
  {
    
    /**
     * ̤ 8˵ؤμ
     * - includes the square where the King is, should rename to 9?
     * - if the king is on the edge, the area is centered.
     */
    template<Player P,class State,class OrigAction>
    struct ToAroundKing8Filter
    {
      BOOST_CLASS_REQUIRE(OrigAction,osl::move_action,Concept);
      const State& state;
      OrigAction & action;
      Position position_king;

    public:
      ToAroundKing8Filter(const State& s, OrigAction & action)
	:
	state(s), action(action),
	position_king(Centering3x3::adjustCenter(s.template getKingPosition<P>()))
      {
      }

      bool isToAroundKing8Move(Position to)
      {
	return to == position_king ||
	  to + Board_Table.getOffsetForBlack(UL)== position_king ||
	  to + Board_Table.getOffsetForBlack(U)== position_king ||
	  to + Board_Table.getOffsetForBlack(UR)== position_king ||
	  to + Board_Table.getOffsetForBlack(L)== position_king ||
	  to + Board_Table.getOffsetForBlack(R)== position_king ||
	  to + Board_Table.getOffsetForBlack(DL)== position_king ||
	  to + Board_Table.getOffsetForBlack(D)== position_king ||
	  to + Board_Table.getOffsetForBlack(DR)== position_king;
      }
      void simpleMove(Position from,Position to,Ptype ptype, bool isPromote,Player p){
	assert(p == P);
	if(isToAroundKing8Move(to))
	  action.simpleMove(from,to,ptype,isPromote,P);
      
      }
      void unknownMove(Position from,Position to,Piece p1,Ptype ptype,bool isPromote,Player p){
	assert(p == P);
	if(isToAroundKing8Move(to))
	  action.unknownMove(from,to,p1,ptype,isPromote,P);
      }
      /**
       * dropMoveˤʤ뤳ȤϤʤ
       */
      void dropMove(Position to,Ptype ptype,Player p){
	assert(p == P);
	if(isToAroundKing8Move(to))
	  action.dropMove(to,ptype,P);
      }
    };
  } // namespace move_action
} // namespace osl

#endif /* _MOVE_TO_AROUND_KING8_FILTER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
