/* blockLongEffect.h
 */
#ifndef _MOVE_CLASSIFIER_BLOCK_LONG_EFFECT_H
#define _MOVE_CLASSIFIER_BLOCK_LONG_EFFECT_H

#include "osl/state/numEffectState.h"

namespace osl
{
  namespace move_classifier
  {
    /**
     * Ĺ֥åȽ.
     * @param P - ư¦Υץ쥤䡼
     * @param T - ֥åμ(ROOK,BISHOP,LANCE)
     */
    template<Player P,Ptype T>
    struct BlockLongEffect
    {
      /**
       * Ĺ֥å.
       * Ȥȥ֥åƤŤʤtrueˤ
       * ü(ζ)ǤΥ֥åϥ֥åʤ
       * ϥ֥åʤ
       * ʣζ֥åϾΤõޤĴ٤
       * @param state - ư
       * @param ptype - ưΰưptype
       * @param from - ưΰưΰ
       * @param to - ưΰưΰ
       */
      static bool isMember(NumEffectState const& state,
			   Ptype /*ptype*/,Position /*from*/,Position to){
	BOOST_STATIC_ASSERT((PtypeFuns<T>::hasLongMove));
	if(!state.getPieceAt(to).isEmpty())return false;
	mask_t e1=state.getOnBoardMask(PlayerTraits<P>::opponent).getMask(PtypeFuns<T>::indexNum);
	mask_t e2=state.getEffect(to).getMask(PtypeFuns<T>::indexNum)>>8;
	mask_t e3=e1 & e2 & mask_t::makeDirect(PtypeFuns<T>::indexMask);
	while(!e3.none()){
	  int num=e3.takeOneBit()+((PtypeFuns<T>::indexNum)<<5);
	  Piece p=state.getPieceOf(num);
	  assert(p.isPiece());
	  assert(p.owner()==PlayerTraits<P>::opponent);
	  assert(unpromote(p.ptype())==T);
	  Offset o=Board_Table.getShortOffset(Offset32(to,p.position()));
	  // EMPTY or Ppiece or alt(P)piece
	  Piece p1=state.getPieceAt(to+o);
	  if(! p1.isEdge())
	    return true;
	}
	return false;
      }
    };

    template<Player P>
    struct BlockLongAny
    {
      static bool isMember(const NumEffectState& state,
			   Ptype ptype,Position from,Position to) {
	return BlockLongEffect<P,ROOK>::isMember(state, ptype, from, to)
	  || BlockLongEffect<P,BISHOP>::isMember(state, ptype, from, to)
	  || BlockLongEffect<P,LANCE>::isMember(state, ptype, from, to);
      }
    };
  }
}
#endif /* _MOVE_CLASSIFIER_BLOCK_LONG_EFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
