/* kingOpenMove.h
 */
#ifndef _MOVE_CLASSIFIER_KING_OPEN_MOVE_H
#define _MOVE_CLASSIFIER_KING_OPEN_MOVE_H

#include "osl/move_classifier/classifierTraits.h"
#include "osl/position.h"
#include "osl/player.h"
#include "osl/ptype.h"

namespace osl
{
  namespace state
  {
    class SimpleState;
  }
  namespace move_classifier
  {
    /**
     * Pβopen checkˤǤʤȤå.
     * - P==move playerλϼ꤫ɤΥå˻Ȥ.
     *      ưˤϸƤ٤ʤ
     * - P!=move playerλ̾open checkɤ˻Ȥ.
     * - DropMoveλˤϸƤ٤ʤ
     */
    template <Player P>
    struct KingOpenMove
    {
      static bool isMember(const state::SimpleState& state, 
			   Ptype ptype,Position from,Position to);
      /**
       * @param exceptFor Ͻ
       */
      static bool isMember(const state::SimpleState& state, 
			   Ptype ptype,Position from,Position to,
			   Position exceptFor);
    private:
      template <bool hasException>
      static bool isMember(const state::SimpleState& state, 
			   Ptype ptype,Position from,Position to,
			   Position exceptFor);
    };

    template <Player P> struct ClassifierTraits<KingOpenMove<P> >
    {
      static const bool drop_suitable = false;
      static const bool result_if_drop = false;
    };
    
  } // namespace move_classifier
} // namespace osl
#endif /* _MOVE_CLASSIFIER_NOT_KING_OPEN_MOVE_H */

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
