#ifndef _ADD_EFFECT8_TABLE_H
#define _ADD_EFFECT8_TABLE_H

#include "osl/ptype.h"
#include "osl/offset32.h"
#include "osl/misc/carray.h"
#include "osl/misc/carray2d.h"
#include "osl/misc/carray3d.h"

#include <utility>

namespace osl
{
  namespace move_generator
  {
    /**
     * Ĥ뤿Υơ֥롥
     * 
     */
    typedef std::pair<Offset,Offset> OffsetPair;
    typedef std::pair<Position,Offset> PO;
    typedef std::pair<Position,OffsetPair> POO;
    class AddEffect8Table
    {
      static const int maxDropPosition=32;
      CArray3d<Position,PTYPE_SIZE,Position::SIZE,maxDropPosition> dropPosition;
      static const int maxLongDropDirect=8;
      CArray3d<Offset,PTYPE_SIZE,Position::SIZE,maxLongDropDirect> longDropDirect;

      static const int maxLongDropPosition=32;
      CArray3d<PO,PTYPE_SIZE,Position::SIZE,maxLongDropPosition> longDropPosition;
      static const int maxLongDrop2Position=8;
      CArray3d<POO,PTYPE_SIZE,Position::SIZE,maxLongDrop2Position> longDrop2Position;

      static const int maxShortMoveOffset=32;
      CArray3d<Offset,PTYPE_SIZE,Offset32::SIZE,maxShortMoveOffset> shortMoveOffset;
      static const int maxShortPromoteMoveOffset=32;
      CArray3d<Offset,PTYPE_SIZE,Offset32::SIZE,maxShortPromoteMoveOffset> shortPromoteMoveOffset;
      static const int maxLongMoveOffset=32;
      CArray3d<OffsetPair,PTYPE_SIZE,Offset32::SIZE,maxLongMoveOffset> longMoveOffset;
      CArray2d<OffsetPair,PTYPE_SIZE,Offset32::SIZE> betweenOffset;
    public:
      AddEffect8Table();

      /**
       * ptypeζǤäŨζ̤8˵ûĤа.
       * Ĺ8˵ˤĤΤ
       * 鸫kingPosition+offset˶ǤĤɤ
       * ֤鸫ζ̤Position
       */
      Position getDropPosition(Ptype ptype,Position kingPosition,int i) const
      {
	//	std::cerr << "getDropOffset(" << ptype << "," << i << ")" << std::endl;
	return dropPosition[ptype](kingPosition.index(),i);
      }

      /**
       * ptypeζǤäŨζ̤8˵ĹĤ.
       * ֤˶𤬤ʤСˤʤ륿
       */
      Offset getLongDropDirect(Ptype ptype,Position kingPosition,int i) const
      {
	return longDropDirect[ptype](kingPosition.index(),i);
      }

      /**
       * ptypeζǤäŨζ̤8˵ĹĤ.
       * 1
       * 鸫kingPosition+firstǤļ꤫Ϥơ+secondƤäƤ
       * emptyʤOK
       */
      PO getLongDropPosition(Ptype ptype,Position kingPosition,int i) const
      {
	return longDropPosition[ptype](kingPosition.index(),i);
      }

      /**
       * ptypeζǤäŨζ̤8˵ĹĤ.
       * 1
       * 鸫kingPosition+firstǤļ꤫Ϥơ+secondƤäƤ
       * emptyʤOK
       */
      POO getLongDrop2Position(Ptype ptype,Position kingPosition,int i) const
      {
	return longDrop2Position[ptype](kingPosition.index(),i);
      }

      /**
       * ptypeζư(Ĺư
       * )Ũζ̤8˵ûĤа.
       * 鸫kingPosition+offset˶ưɤ
       * @param isPromote - promote뤫ʤ
       * @param ptype - ưζμ
       * @param o32 - targetߤfromа = Offset32(from,target)
       * @param i - ܤ
       */
      Offset getShortMoveOffset(bool isPromote,Ptype ptype,Offset32 o32,int i) const
      {
	if(!isPromote){
	  assert(i<maxShortMoveOffset);
	  return shortMoveOffset[ptype](o32.index(),i);
	}
	else{
	  assert(i<maxShortPromoteMoveOffset);
	  return shortPromoteMoveOffset[ptype](o32.index(),i);
	}
      }
      /**
       * ptypeζưŨζ̤8˵ĹĤа.
       * 鸫kingPosition+first˶ưǤơ
       * kingPosition+secondȤδ֤äemptyʤɤ
       * @param ptype - ưζμ
       * @param o32 - targetߤfromа = Offset32(from,target)
       * @param i - ܤ
       */
      OffsetPair getLongMoveOffset(Ptype ptype,Offset32 o32,int i) const
      {
	assert(i<maxLongMoveOffset);
	return longMoveOffset[ptype](o32.index(),i);
      }
      /**
       * ptypeζŨζ𤬤ʤ8˵Ĺ.
       * secondˤɤäkingPosition+firstޤǤ˼⤬1Ĥʤɤ
       * @param ptype - ưζμ
       * @param o32 - targetߤfromа = Offset32(from,target)
       */
      OffsetPair getBetweenOffset(Ptype ptype,Offset32 o32) const
      {
	return betweenOffset[ptype][o32.index()];
      }
    private:
      void initDropPosition();
      void initLongDropPosition();
      void initMoveOffset();
    };
    extern const AddEffect8Table Add_Effect8_Table;

  } // namespace move_generator
} // namespace osl
#endif /* _ADD_EFFECT8_TABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
