#ifndef _MOVE_GENERATER_ADD_EFFECT_WITH_EFFECT_H
#define _MOVE_GENERATER_ADD_EFFECT_WITH_EFFECT_H
#include "osl/loki.h"
#include "osl/effect_action/simpleNoPromote.h"
#include "osl/effect_action/noPromote.h"
#include "osl/effect_action/simplePromote.h"
#include "osl/effect_action/promote.h"
#include "osl/effect_action/simpleMove.h"
#include "osl/effect_action/alwaysMove.h"
#include "osl/effect_action/betterToPromote.h"
#include "osl/effect_action/simpleBetterToPromote.h"
#include "osl/move_action/concept.h"
#include <boost/static_assert.hpp>

// AddEffectWithEffect<NumEffectState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateAddEffectWithEffectMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace move_generator
  {
    using namespace effect_action;
    /**
     * Ĥ stateǤȤʤ.
     * AddEffect٤ΤǺȤʤäƤϰ̣Ϥʤ
     * 르ꥺ:
     * \li Ĥޥ8˵(Ĺ)϶˵μʬå
     * \li ʬäˡ˰ưΥޥĤμफå
     * ħ:
     * \li ̤μͳ٤˵˼ʬʤϹ®Ƚ
     * \li ʿŪˤAddEffectˤ®٤ǤϵڤФʤ
     */
    template<class State,class Action>
    class AddEffectWithEffect
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      BOOST_STATIC_ASSERT(sizeof(typename State::effect_state_t));
    public:
      /**
       * @param ǽInt2Type : DirectionTypeĤ
       * @param Int2Type ; pawnɤ
       */
      template<Player P>
      static void generateDropSub(const State& state,Position pos,Ptype ptype,Action& action,Int2Type<false>,Int2Type<true>){
      }
      template<Player P>
      static void generateDropSub(const State& state,Position pos,Ptype ptype,Action& action,Int2Type<false>,Int2Type<false>){
      }
      template<Player P>
      static void generateDropSub(const State& state,Position pos,Ptype ptype,Action& action,Int2Type<true>,Int2Type<true>){
	if(!state.isPawnMaskSet(P,pos.x()) &&
	   state.template hasPieceInStand<P,PAWN>())
	  action.dropMove(pos,PAWN,P);
      }
      template<Player P>
      static void generateDropSub(const State& state,Position pos,Ptype ptype,Action& action,Int2Type<true>,Int2Type<false>){
	if(state.hasPieceInStand(P,ptype))
	  action.dropMove(pos,ptype,P);
      }
      template<Player P,Direction Dir,Ptype Type>
      static void generateDrop(const State& state,Position pos,Action& action){
	generateDropSub<P>(state,pos,Type,action,Int2Type<PtypeDirectionTraits<Type,Dir>::canMove>(),Int2Type<Type==PAWN>());
      }
      // simple moves
      template<Player P,Ptype Type,MoveType mt>
      static void generateSimpleMovesToSub(const State& state,Position from,Action& action,Int2Type<mt>);

      template<Player P,Ptype Type>
      static void generateSimpleMovesToSub(const State& state,Position from,Action& action,Int2Type<CannotMove>){
      }

      template<Player P,Ptype Type>
      static void generateSimpleMovesToSub(const State& state,Position from,Action& action,Int2Type<NoConstraint>){
	SimpleMove<Action> ac(action);
	state.template forEachEffectPtype<P,Type,SimpleMove<Action>  >(from,ac);
      }

      template<Player P,Ptype Type>
      static void generateSimpleMovesToSub(const State& state,Position from,Action& action,Int2Type<OnlyPromoted>){
	SimplePromote<Action> ac(action);
	state.template forEachEffectPtype<P,Type,SimplePromote<Action>  >(from,ac);
      }

      template<Player P,Ptype Type>
      static void generateSimpleMovesToSub(const State& state,Position from,Action& action,Int2Type<OnlyBasic>){
	SimpleNoPromote<Action> ac(action);
	state.template forEachEffectPtype<P,Type,SimpleNoPromote<Action>  >(from,ac);
      }

      template<Player P,Direction Dir,Ptype Type>
      static void generateSimpleMovesTo(const State& state,Position from,Action& action);

      // capture moves
      template<Player P,Ptype Type,MoveType mt>
      static void generateCaptureMovesToSub(const State& state,Position from,Action& action,Int2Type<mt>);

      template<Player P,Ptype Type>
      static void generateCaptureMovesToSub(const State& state,Position from,Action& action,Int2Type<noMove>){
      }

      template<Player P,Ptype Type>
      static void generateCaptureMovesToSub(const State& state,Position from,Action& action,Int2Type<alwaysMove>){
	AlwaysMove<State,Action> ac(state, action);
	state.template forEachEffectPtype<P,Type,AlwaysMove<State,Action>  >(from,ac);
      }

      template<Player P,Ptype Type>
      static void generateCaptureMovesToSub(const State& state,Position from,Action& action,Int2Type<promoteMove>){
	Promote<State,Action> ac(state, action);
	state.template forEachEffectPtype<P,Type,Promote<State,Action>  >(from,ac);
      }

      template<Player P,Ptype Type>
      static void generateCaptureMovesToSub(const State& state,Position from,Action& action,Int2Type<noPromoteMove>){
	NoPromote<State,Action> ac(state, action);
	state.template forEachEffectPtype<P,Type,NoPromote<State,Action>  >(from,ac);
      }


      template<Player P,Direction Dir,Ptype Type>
      static void generateCaptureMovesTo(const State& state,Position from,Action& action);

      /** including unpromoted knights*/
      template<Player P,Direction Dir>
      static void generateEffectDir(const State& state,Position pos,Action& action);
      /** unpomoted knights only 
       *  (1,1)˸ηϤ뤫åݤˡPosition::STAND()position
       ξܤåޤξܤPIECE_EDGE񤫤Ƥ뤳Ȥꤵ
       Ƥޤ
      */
      template<Player P,Direction Dir>
      static void generateEffectDirKnight(const State& state,Position pos,Action & action){
	Position pos1=pos-DirectionPlayerTraits<Dir,P>::offset();
	Piece p=state.getPieceAt(pos1);
	if(p.isEmpty()){
	  // short֤
	  generateDrop<P,Dir,KNIGHT>(state,pos1,action);
	  // Knight뤫ɤ
	  // promoteƤʤɤ
	  SimpleNoPromote<Action> ac(action);
	  state.template forEachEffectPtype<P,KNIGHT,SimpleNoPromote<Action>  >(pos1,ac);
	}
	else if(canMoveOn<P>(p)){ 
	  NoPromote<State,Action> ac(state, action);
	  state.template forEachEffectPtype<P,KNIGHT,NoPromote<State,Action>  >(pos1,ac);
	}
      }
      template<Player P>
      static void generateMoves(const State& state,Position pos,Action& action);
      static void generateMoves(Player p, const State& state, Position pos, Action& action)
      {
	if (p == BLACK)
	  generateMoves<BLACK>(state, pos, action);
	else
	  generateMoves<WHITE>(state, pos, action);
      }
    };				// AddEffectWithEffect

    template<class State,class Action>
    template<Player P,Direction Dir,Ptype Type>
    inline
    void AddEffectWithEffect<State,Action>::generateSimpleMovesTo(const State& state,Position from,Action& action){
      // promoteѤߤʤpromoteʤǤʤ
      // ư
      // promoteѤߤʤʤpromoteʤ
      // ɤǤʤ
      generateSimpleMovesToSub<P,Type>(state,from,action,Int2Type<PtypeDirectionTraits<Type,Dir>::moveType >());
    }
    template<class State,class Action>
    template<Player P,Direction Dir,Ptype Type>
    inline
    void AddEffectWithEffect<State,Action>::generateCaptureMovesTo(const State& state,Position from,Action& action){
      // promoteѤߤʤpromoteʤǤʤ
      // ư
      // promoteѤߤʤʤpromoteʤ
      // ɤǤʤ
      generateCaptureMovesToSub<P,Type>
	(state,from,action,
	 Int2Type<PtypeDirectionTraits<Type,Dir>::moveType >());
    }

  } // namespace move_generator
} // namespace osl
#endif /* _MOVE_GENERATER_ADD_EFFECT_WITH_EFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
