#ifndef _GENERATE_ALL_MOVES_TCC
#define _GENERATE_ALL_MOVES_TCC
#include "osl/move_generator/allMoves.h"
#include "osl/move_generator/pieceOnBoard.tcc"
#include "osl/move_generator/drop.h"
#include "osl/move_action/concept.h"
#include "osl/move_action/store.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace move_generator
  {
    /**
     * promtoeǽTλ
     */
    template<typename State,typename Action,Player P,Ptype T>
    struct EachOnBoard
    {
      const State& state;
      Action& action;
      EachOnBoard(const State& state,Action& action):state(state),action(action){}
      void operator()(Piece p){
	PieceOnBoardType<P,T>::generate(state,p,action);
      }
    };

    template<class State,class Action>
    template<Player P,Ptype T>
    void AllMoves<State, Action>::
    generateMovesPtype(const State& state, Action& action){
      typedef EachOnBoard<State,Action,P,T> each_t;
      each_t eachOnBoard(state,action);
      state.template forEachOnBoard<P,T,each_t>(eachOnBoard);
    }


    /**
     * ٤Ƥμ
     * StatePawnMaskľ
     */
    template<class State,class Action>
    template<Player P>
    void AllMoves<State, Action>::
    generateMoves(const State& state, Action& action,Int2Type<true>)
    {
      generateMovesPtype<P,PAWN>(state,action);
      generateMovesPtype<P,LANCE>(state,action);
      generateMovesPtype<P,KNIGHT>(state,action);
      generateMovesPtype<P,SILVER>(state,action);
      generateMovesPtype<P,GOLD>(state,action);
      generateMovesPtype<P,BISHOP>(state,action);
      generateMovesPtype<P,ROOK>(state,action);
      generateMovesPtype<P,KING>(state,action);
      Drop<typename State::pawn_mask_state_t,Action>
	::template generateMoves<P>(state,action);
    }

    /**
     * promtoeǽTλ
     */
    template<typename State,typename Action,Player P>
    struct EachOnBoardWithPawnMask{
      const State& state;
      Action& action;
      BitXmask &pawnMask;
      EachOnBoardWithPawnMask(const State& state,Action& action,BitXmask& pawnMask):state(state),action(action),pawnMask(pawnMask){}
      void operator()(Piece p){
	PieceOnBoard<P>::generateMovesPawn(state,p,action,pawnMask);
      }
    };

    template<class State,class Action>
    template<Player P>
    void AllMoves<State, Action>::
    generateMovesPawn(const State& state, Action& action,BitXmask &pawnMask){
      typedef EachOnBoardWithPawnMask<State,Action,P> each_t;
      each_t eachOnBoard(state,action,pawnMask);
      state.template forEachOnBoard<P,PAWN,each_t>(eachOnBoard);
    }

    /**
     * ٤Ƥμ
     * StatePawnMaskʤ
     */
    template<class State,class Action>
    template<Player P>
    void AllMoves<State, Action>::
    generateMoves(const State& state, Action& action,Int2Type<false>)
    {
      /**
       * pawnäƤʤpawnMaskϵˤʤƤɤ
       */
      BitXmask pawnMask;;
      if(state.template hasPieceInStand<P,PAWN>()){
	generateMovesPawn<P>(state,action,pawnMask);
      }
      else{
	generateMovesPtype<P,PAWN>(state,action);
      }
      generateMovesPtype<P,LANCE>(state,action);
      generateMovesPtype<P,KNIGHT>(state,action);
      generateMovesPtype<P,SILVER>(state,action);
      generateMovesPtype<P,GOLD>(state,action);
      generateMovesPtype<P,BISHOP>(state,action);
      generateMovesPtype<P,ROOK>(state,action);
      generateMovesPtype<P,KING>(state,action);
      Drop<typename State::pawn_mask_state_t,Action>
	::template generateMovesWithPawnMask<P>(state,action,pawnMask);
    }

    /**
     * ٤Ƥμ
     * StatepawnMaskĤɤ dispatch
     */
    template<class State,class Action>
    template<Player P>
    void AllMoves<State, Action>::
    generateMoves(const State& state, Action& action){
      AllMoves<State, Action>::template
	generateMoves<P>(state,action,Int2Type<State::hasPawnMask>());
    }


  } // namespace move_generator
} // namespace osl

template <class State>
void osl::GenerateAllMoves::
generate(Player p, const State& state, container::MoveVector& out)
{
  typedef move_action::Store store_t;
  store_t store(out);
  move_generator::AllMoves<State,store_t>::generateMoves(p, state, store);
}

#endif /* _GENERATE_ALL_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
