/* generateCaptureMoves.tcc
 */
#ifndef _GENERATECAPTUREMOVES_TCC
#define _GENERATECAPTUREMOVES_TCC

#include "osl/move_generator/capture_.h"
#include "osl/effect_action/alwaysMove.h"
#include "osl/player.h"

namespace osl
{
  namespace move_generator
  {
    using namespace effect_action;

    template<Player P>
    template<class State,class Action>
    void Capture<P>::
    generate(const State& state,Position target,Action& action)
    {
      AlwaysMove<State,Action> captureAction(state, action);
      state.template forEachEffect<P,AlwaysMove<State,Action> >(target,captureAction);
    }

    template<Player P>
    template<class State,class Action>
    void Capture<P>::
    escapeByCapture(const State& state,Position target,Piece piece,Action& action)
    {
      AlwaysMove<State,Action> captureAction(state, action);
      state.template forEachEffectNotBy<P,AlwaysMove<State,Action> >(target,piece,captureAction);
    }

  } // namespace move_generator
} // namespace osl

#endif /* _GENERATECAPTUREMOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
