#ifndef _GENERATE_ESCAPE_MOVES_H
#define _GENERATE_ESCAPE_MOVES_H
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_generator/capture_.h"
#include "osl/effect_action/simpleMove.h"
#include "osl/effect_action/pieceFilter.h"
#include "osl/move_action/noEffectFilter.h"
#include "osl/move_action/notKingOpenFilter.h"
#include "osl/move_action/concept.h"
#include "osl/effect/liberty8.h"
#include "osl/move.h"
// EscapeMoves<NumEffectState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateEscapeMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace container
  {    
    class MoveVector;
  }
  namespace move_generator
  {
    /**
     * ƨ
     * unique
     * ˴ؤƤϰϷŪƨƤʤƤ
     * ͽ
     */
    template<Player P,class State,class Action>
    class Escape
    {
      //      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      typedef move_action::NotKingOpenFilter<P,State,Action> safe_action_t;
//    private:
    public:
      /**
       * ζ뤳Ȥˤäƨ.
       * ƨФǼʤ2003/5/12
       * @param target toru koma no pos
       */
      static void generateCaptureKing(const State& state,Piece p,Position target,safe_action_t& action) {
	Capture<P>::escapeByCapture(state,target,p,action);
      }
      static void generateCapture(const State& state,Piece p,Position target,Action& action) {
	Capture<P>::escapeByCapture(state,target,p,action);
      }
      template<Ptype Type>
      static void generateEscape(const State& state,Piece p,Action& action,Int2Type<Type>);
      /**
       * @param p ƨФ
       */
      template<Ptype Type>
      static void generateEscape(const State& state,Piece p,Action& action){
	/**
	 * @param ξ̰Ǥ
	 */
#if 1
	if(Type==KING){
	  assert(p.owner()==P && p.ptype()==KING);
	  Position from=p.position();
	  effect::Liberty8<P> libertyKing(state,from);
	  NearMask nearMask=libertyKing.getMask();
	  /*
	   * ʲΥ롼8Ĥξʸ®⤷ʤ
	   */
	  while(nearMask.any()){
	    const int i=nearMask.takeOneBit();
	    assert(0<=i && i<=7);
	    Direction dir=static_cast<Direction>(i);
	    Offset offset=Board_Table.getOffset<P>(dir);
	    // dir, dirư򤹤fromϤʤΤ
	    // -offset
	    Position to=from-offset;
	    action.unknownMove(from,to,state.getPieceAt(to),KING,false,P);
	  }
	}
	else
#endif
	{
	  typedef move_action::NoEffectFilter<P,State,Action> CheckAction;
	  CheckAction checkAction(state,action,p.position());
	  PieceOnBoardType<P,Type>::generate(state,p,checkAction);
	}
      }

      template<Ptype Type>
      static void generateDrop(const State& state,Position to,Action& action){
	if(state.template hasPieceOnStand<P,Type>()){
	  if((Type!=PAWN || !state.isPawnMaskSet(P,to.x())) &&
	     PtypePlayerTraits<Type,P>::canDropTo(to)){
	    action.dropMove(to,Type,P);
	  }
	}
      }

      static void generateDropAll(const State& state,Position to,Action& action);
      /**
       *  
       */
      static void generateBlocking(const State& state,Piece p,Position from,Action& action);
      static void generateBlockingKing(const State& state,Piece p,Position from,Action& action,safe_action_t& safe_action);
    public:
      static void generateKingEscape(const State& state,Move last_move,Action& action);

      /** 
       * @param p 㤨 king
       */
      template<Ptype Type>
      static void generateMovesBy(const State& state,Piece p,Piece attackerPiece,Action& action);
      template<Ptype Type>
      static void generateMovesBy(const State& state,Piece p,Move last_move,Action& action);
      template<Ptype Type>
      static void generateMovesBy(const State& state,Piece p,Action& action);
    
      /**
       * ƨ
       * unique
       * ˴ؤƤϰϷŪƨƤʤƤ
       * ͽ
       * @param p ƨplayer
       * @param piece ƨ
       * @param last_move - μ
       */
      static /* inline */ void generateMoves(const State& state,Piece piece,Move last_move,Action& action);
      /**
       */
      static /* inline */ void generateMoves(const State& state,Piece piece,const Piece attackerPiece,Action& action);
      /**
       * last_moveƨ
       */
      static /* inline */ void generateMoves(const State& state,Piece piece,Action& action);
    };

    template <Player P>
    struct GenerateEscape
    {
      template <class State, class Action>
      static void generate(const State& state, Piece piece, Action& a)
      {
	Escape<P,State,Action>::generateMoves(state, piece, a);
      }
    };
    struct GenerateEscapeOfTurn
    {
      template <class State, class Action>
      static void generate(const State& state, Piece piece, Action& a)
      {
	if (state.getTurn() == BLACK)
	{
	  Escape<BLACK,State,Action>::generateMoves(state, piece, a);
	}
	else
	{
	  Escape<WHITE,State,Action>::generateMoves(state, piece, a);
	}
      }
    };

  } // namespace move_generator
  struct GenerateEscapeKing
  {
    template <class State>
    static void generate(const State& state, container::MoveVector& out);
  };
  using move_generator::GenerateEscape;
} // namespace osl
#endif // _GENERATE_ESCAPE_MOVES_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
