/* effect5x3.h
 */
#ifndef PROGRESS_EFFECT5X3_H
#define PROGRESS_EFFECT5X3_H

#include "osl/progress/progress16.h"
#include "osl/state/numEffectState.h"
#include "osl/centering5x3.h"
#include "osl/misc/carray.h"
#include <algorithm>
namespace osl
{
  namespace progress
  {
    /**
     * ̤μ5x3ΰοȻ𤫤׻ʹ.
     * 5x3ΰˤʤ褦롥
     * ξοʹ٤ġ
     * νŤߤ
     * PAWN 1
     * LANCE 4
     * KNIGHT,SILVER,GOLD 8
     * BISHOP,ROOK 12
     * ο8νŤߤġ
     */
    struct Effect5x3
    {
    private:
      static void updateStand(int& old_stand, Move last_move);
      static int makeProgressAll(Player defense, const NumEffectState& state,
				 Position king);
      static int makeProgressArea(Player attack, const NumEffectState& state,
				  Position king);
      static int makeProgressAreaBonus(Player attack,
				       const NumEffectState& state,
				       Position king);
    public:
      static int makeProgressStand(Player attack, const NumEffectState& state);
      /**
       * ΰ֤ꤷprogressη׻.
       * @param defense - ζ̤ܤprogress
       * @param state - 
       * @param king - ̤ΰ֤ˤȤ롥
       * ̤ˤϡ̤̤ΰ֤Ǥ뤬ʬ׻Ǥ
       * פʤȤƸƤӽФȤ롥
       */
      static int makeProgress(Player defense, const NumEffectState& state){
	return makeProgressAll(defense,state,state.getKingPosition(defense));
      }
      static int makeProgress(const NumEffectState& state)
      {
	return makeProgress(BLACK, state) + makeProgress(WHITE, state);
      }
      /**
       * 0-15 ֤ͤ
       */
      static const Progress16 progress16(int progress)
      {
	assert(progress >= 0);
	const int rank = progress / 8; // Ŭ
	return Progress16(std::min(rank, 15));
      }
      /**
       * 0-15 ֤ͤ.
       * ץ쥤Ŀ
       */
      static const Progress16 progress16each(int progress)
      {
	assert(progress >= 0);
	const int rank = progress / 8; // Ĵ
	return Progress16(std::min(rank, 15));
      }
    private:
      CArray<int,2> progresses, progress_bonuses, stand_progresses;
    public:
      explicit Effect5x3(const NumEffectState& state) 
      {
	progresses[playerToIndex(BLACK)]=makeProgress(BLACK, state);
	progresses[playerToIndex(WHITE)]=makeProgress(WHITE, state);
	progress_bonuses[playerToIndex(BLACK)]=makeProgressAreaBonus(WHITE, state, state.getKingPosition<BLACK>());
	progress_bonuses[playerToIndex(WHITE)]=makeProgressAreaBonus(BLACK, state, state.getKingPosition<WHITE>());
	stand_progresses[playerToIndex(WHITE)]=makeProgressStand(BLACK, state);
	stand_progresses[playerToIndex(BLACK)]=makeProgressStand(WHITE, state);
      }
      void changeTurn() {}
      int progress(Player p) const { return progresses[playerToIndex(p)]; }
      const Progress16 progress16() const
      {
	return progress16(progresses[0] + progresses[1]);
      }
      const Progress16 progress16(Player p) const
      {
	return progress16each(progress(p));
      }
      const Progress16 progress16bonus(Player p) const
      {
	return progress16each(progress_bonuses[playerToIndex(p)] +
			      stand_progresses[playerToIndex(p)]);
      }
      // ɬפʤ
      Effect5x3 expect(const NumEffectState& state, Move move) const;
      void update(const NumEffectState& new_state, Move last_move);
    };
  } // namespace progress
} // namespace osl

#endif /* PROGRESS_EFFECT5X3_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
