/* effect5x3.h
 */
#ifndef PROGRESS_EFFECT5X3D_H
#define PROGRESS_EFFECT5X3D_H

#include "osl/progress/progress16.h"
#include "osl/state/numEffectState.h"
#include "osl/centering5x3.h"
#include "osl/misc/carray.h"
#include <algorithm>
namespace osl
{
  namespace progress
  {
    /**
     * ̤μ5x3ΰο׻̤Τޤο
     * 5x3ΰˤʤ褦롥
     * ξοʹ٤ġ
     * Effect5x3 Ȥΰ㤤νŤߤʤ
     */
    struct Effect5x3d
    {
      /**
       * ΰ֤ꤷprogressη׻.
       * @param defense - ζ̤ܤprogress
       * @param state - 
       * @param king - ̤ΰ֤ˤȤ롥
       * ̤ˤϡ̤̤ΰ֤Ǥ뤬ʬ׻Ǥ
       * פʤȤƸƤӽФȤ롥
       */
      static int makeProgress(Player defense, const NumEffectState& state,
			      Position king);
      static int makeProgress(Player defense, const NumEffectState& state){
	return makeProgress(defense,state,state.getKingPosition(defense));
      }
      static int makeProgress(const NumEffectState& state)
      {
	return makeProgress(BLACK, state) + makeProgress(WHITE, state);
      }
      /**
       * 0-15 ֤ͤ
       */
      static const Progress16 progress16(int progress)
      {
	assert(progress >= 0);
	const int rank = progress / 8 - 16; // Ŭ
	return Progress16(std::max(std::min(rank, 15), 0));
      }
      /**
       * 0-15 ֤ͤ.
       * ץ쥤Ŀ
       */
      static const Progress16 progress16each(int progress)
      {
	assert(progress >= 0);
	const int rank = progress / 8 - 8; // Ĵ
	return Progress16(std::max(std::min(rank, 15), 0));
      }
    private:
      CArray<int,2> progresses;
    public:
      explicit Effect5x3d(const NumEffectState& state) 
      {
	progresses[playerToIndex(BLACK)]=makeProgress(BLACK, state);
	progresses[playerToIndex(WHITE)]=makeProgress(WHITE, state);
      }
      void changeTurn() {}
      int progress(Player p) const { return progresses[playerToIndex(p)]; }
      const Progress16 progress16() const
      {
	return progress16(progresses[0] + progresses[1]);
      }
      const Progress16 progress16(Player p) const
      {
	return progress16each(progress(p));
      }
      // ɬפʤ
      void update(const NumEffectState& new_state, Move last_move);
    };
  } // namespace progress
} // namespace osl

#endif /* PROGRESS_EFFECT5X3D_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
