/* capture.h
 */
#ifndef _CAPTURE_H
#define _CAPTURE_H

#include "osl/rating/feature.h"
#include "osl/eval/pieceEval.h"
#include "osl/effect_util/shadowEffect.h"

namespace osl
{
  namespace rating
  {
    class Capture : public Feature
    {
    public:
      enum { INF = 999999 };
    private:
      int first, last;
      static const std::string name(int first, int last);
    public:
      Capture(int f, int l) : Feature(name(f, l)), first(f), last(l) {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	int see = PieceEval::computeDiffAfterMoveForRP(state, move);
	see = see*100/128;
	return first <= see && see < last;
      }
    };

    class ShadowEffect1 : public Feature
    {
    public:
      ShadowEffect1() : Feature("ShadowEffect1") {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	return ShadowEffect::count2(state, move.to(), move.player()) == 1;
      }
    };

    class ShadowEffect2 : public Feature
    {
    public:
      ShadowEffect2() : Feature("ShadowEffect2") {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	return ShadowEffect::count2(state, move.to(), move.player()) == 2;
      }
    };

  }
}


#endif /* _CAPTURE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
