/* checkmate.h
 */
#ifndef _CHECKMATE_H
#define _CHECKMATE_H

#include "osl/rating/feature.h"
#include "osl/checkmate/immediateCheckmate.h"
#include "osl/checkmate/checkmateIfCapture.h"

namespace osl
{
  namespace rating
  {
    class CheckmateIfCapture : public Feature
    {
    public:
      CheckmateIfCapture() : Feature("CheckmateCap") {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	return checkmate::CheckmateIfCapture::effectiveAttack
	  (const_cast<NumEffectState&>(state), move, 0); // XXX: evil cast
      }
    };

    class Threatmate : public Feature
    {
    public:
      Threatmate() : Feature("Threatmate") {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const;
      struct Helper;
    };

  }
}


#endif /* _CHECKMATE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
