/* countEffect2.h
 */
#ifndef _COUNTEFFECT2_H
#define _COUNTEFFECT2_H

#include "osl/state/numEffectState.h"
#include "osl/effect_util/additionalEffect.h"

namespace osl
{
  namespace rating
  {
    struct CountEffect2
    {
      static const int Max = 2;
      int attack, defense;
      CountEffect2(int a, int d) : attack(a), defense(d)
      {
      }
      static std::pair<int,int> count(const NumEffectState& state, Position position) 
      {
	int attack = 0, defense = 0;
	if (position.isOnBoard()) {
	  assert(position.isOnBoard());
	  const Player turn = state.getTurn();
	  attack = std::min(Max, state.countEffect(turn, position));
	  defense = std::min(Max, state.countEffect(alt(turn), position));
	  if (attack && (attack < Max))
	    attack = std::min(Max, attack+AdditionalEffect::count2(state, position, turn));
	  if (defense && (defense < Max))
	    defense = std::min(Max, defense+AdditionalEffect::count2(state, position, alt(turn)));
	}
	return std::make_pair(attack, defense);
      }
      bool match(const NumEffectState& state, Position position) const
      {
	std::pair<int,int> ad = count(state, position);
	return attack == ad.first && defense == ad.second;
      }
      static std::string name(int attack, int defense);
      static int index(const NumEffectState& state, Position position) 
      {
	std::pair<int,int> ad = count(state, position);
	return ad.first*(Max+1)+ad.second;
      }
    };
  }
}

#endif /* _COUNTEFFECT2_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
