/* escape.h
 */
#ifndef _ESCAPE_H
#define _ESCAPE_H

#include "osl/rating/feature.h"
#include "osl/rating/feature/countEffect2.h"

namespace osl
{
  namespace rating
  {
    /** ưؤΤattack defense ϸդΰ̣ȵդǼʬattack */
    class FromEffect : public Feature, CountEffect2
    {
    public:
      FromEffect(int attack, int defense) 
	: Feature("FE"+CountEffect2::name(attack, defense)), CountEffect2(attack, defense) {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	return ! move.isDrop() && CountEffect2::match(state, move.from());
      }
    };

    class PtypeAttacked : public Feature
    {
      Ptype self, attack;
    public:
      PtypeAttacked(Ptype s, Ptype a) 
	: Feature(std::string(Ptype_Table.getCsaName(s))+"<"+Ptype_Table.getCsaName(a)), 
	  self(s), attack(a)
      {
      }
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	return move.oldPtype() == self
	  && ! move.isDrop()
	  && EffectUtil::cheapestPiece(alt(move.player()), state, move.from()).ptype()== attack;
      }
    };

    class ToSupported : public Feature
    {
    public:
      ToSupported() : Feature("ToSupported") {}
      bool match(const NumEffectState& state, Move move, const RatingEnv&) const
      {
	return state.hasEffectBy(move.player(), move.to());
      }
    };
  }
}

#endif /* _ESCAPE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
