/* checkmateSearcherHolder.h
 */
#ifndef OSL_CHECKMATESEARCHERHOLDER_H
#define OSL_CHECKMATESEARCHERHOLDER_H

#include <boost/scoped_ptr.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/utility.hpp>

namespace osl
{
  namespace search
  {
    class Worker;
    /**
     * åɤ DualCheckmateSearcher бŤ.
     */
    template <class Checkmate>
    class CheckmateSearcherHolder : boost::noncopyable
    {
      class Table;
      boost::scoped_ptr<Table> table;
    public:
      explicit CheckmateSearcherHolder(const Checkmate& seed);
      ~CheckmateSearcherHolder();
      
      Checkmate *clone(const Worker *key);
      boost::shared_ptr<Checkmate> cloneShared(const Worker *key);
      void clear();
      size_t totalNodeCount() const;
    };
    
  }
}

#endif /* OSL_CHECKMATESEARCHERHOLDER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
