/* hasTimer.h
 */
#ifndef _HASTIMER_H
#define _HASTIMER_H
#include "osl/misc/realTime.h"
#include "osl/misc/lightMutex.h"
namespace osl
{
  namespace search
  {
    class HasTimer 
    {
      /** õλͽ */
      misc::RealTime stop_schedule;
      typedef LightMutex Mutex;
      mutable Mutex mutex;
      /** ֤ܻĤäƤ鼡iteration ˿ʤफ */
      volatile double next_iteration_coefficient;
    public:
      HasTimer() : stop_schedule(-1), next_iteration_coefficient(4.0) {
      }
      HasTimer(const HasTimer& src) : stop_schedule(src.stopSchedule()) {
      }
      virtual ~HasTimer();
      void setStopSchedule(const misc::RealTime& schedule) {
	Mutex::scoped_lock lk(mutex);
	stop_schedule = schedule;
      }
      bool hasSchedule() const {
	Mutex::scoped_lock lk(mutex);
	return ! stop_schedule.isInvalid();
      }
      const misc::RealTime stopSchedule() const {
	Mutex::scoped_lock lk(mutex);
	return stop_schedule;
      }
      void setNextIterationCoefficient(double new_value) {
	Mutex::scoped_lock lk(mutex);
	next_iteration_coefficient = new_value;
      }
      double nextIterationCoefficient() const {
	Mutex::scoped_lock lk(mutex);
	return next_iteration_coefficient;
      }
    };
  } // namespace search
} // namespace osl


#endif /* _HASTIMER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
