/* historyTable.h
 */
#ifndef OSL_SEARCH_HISTORYTABLE_H
#define OSL_SEARCH_HISTORYTABLE_H

#include "osl/state/numEffectState.h"
#include "osl/container/moveLogProbVector.h"
#include <boost/shared_ptr.hpp>
#include <iosfwd>

namespace osl
{
  namespace search
  {
    class HistoryTable
    {
      class Table;
      boost::shared_ptr<Table> table;
      static const int maximum_logp = 2000;
    public:
      HistoryTable();
      ~HistoryTable();
      void clear();

      HistoryTable& operator=(const HistoryTable&);

      void setMove(int depth_left, Move best_move);
      void getMoves(const NumEffectState&, MoveLogProbVector& moves) const;

      /** @return 2000 if not found */
      int logp(Move) const;
      static int logp(double);

      double count(Move) const;
      void dump(std::ostream&) const;
    };
  } // namespace search
  using search::HistoryTable;
} // namespace osl

#endif /* OSL_SEARCH_HISTORYTABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
