/* simpleHashTable.h
 */
#ifndef _SIMPLE_HASHTABLE_H
#define _SIMPLE_HASHTABLE_H

#include "osl/container/generalSimpleHashTable.h"
#include "osl/container/moveVector.h"
namespace osl
{
  namespace search
  {
    struct SimpleHashRecord;

    /**
     * Ū hash table.
     * Ȥꤢ g++ (SGI STL)  hash_map ȤäƼ
     *
     * ǽ:
     * - lower bound  upper bound Ͽ롣
     * - ⤷ϿƤ̤˺ƤϿä顤ƾ񤭤
     * - ꤬դ줿ñ̵뤹
     * - upperBound  lowerBound  player ¸(betterThan)ʤΤ
     *   ֤ΰ㤦Ʊ̤þ
     * - Ͽ
     *
     * ٴŪʵǽ顤ʬǼʤۤbetter
     *  hash_map Ǥ GC뤳ȤϺȻפ뤿
     *
     * find, allocate  ݥ󥿤֤ᡤǤɲäƤ⡤¸Ǥ
     * ɥ쥹Ѳʤǡ¤Ѥɬפ롥
     */
    class SimpleHashTable : private container::GeneralSimpleHashTable<SimpleHashRecord>
    {
    private:
      int minimum_limit;
      int verbose;
    public:
      /**
       * @param capacity ɽݻ
       * @param minimumRecordLimit recordUpperBound, recordLowerBound ˤ
       *    limit ̤ΤΤϿ׵̵뤹.
       *    üŻõ⵭Ͽϥޥʥˤ
       */
      explicit SimpleHashTable(unsigned int capacity=100000, 
			       int minimum_record_limit=0,
			       int verbose=0);
      ~SimpleHashTable();

      using GeneralSimpleHashTable<SimpleHashRecord>::clear;
      /**
       * @param new_limit recordUpperBound, recordLowerBound ˤ 
       *   limit ̤ΤΤϿ׵̵뤹
       */
      void setMinimumRecordLimit(int new_limit);

      /**
       * ɽõϿƤʤпȥϿ
       * @return ơ֥뤬äѤälimit 0
       *   ǤʤǳݤؤΥݥ
       *   (ְäƤ delete ʤ)
       * @throw TableFull
       */
      SimpleHashRecord *allocate(const HashKey& key, int limit);

      /**
       * ɽõϿϤʤ
       * @return ¸ߤʤ0
       *   ǤʤǳݤؤΥݥ
       *   (ְäƤ delete ʤ)
       */
      using GeneralSimpleHashTable<SimpleHashRecord>::find;

      int minimumRecordLimit() const;
      using GeneralSimpleHashTable<SimpleHashRecord>::size;
      using GeneralSimpleHashTable<SimpleHashRecord>::capacity;

      void setVerbose(int verbose=1);
      int verboseLevel() const;
      bool isVerbose() const { return verboseLevel(); }

      /**
       * root  depth λؼ out¸
       * @param max_depth ʾοϥԡʤ
       * @param min_limit ʲμ¸Ψϥԡʤ
       * @return root record
       */
      SimpleHashRecord* migrate(const HashKey& root, 
				int max_depth, int min_limit,
				SimpleHashTable& out) const;
      bool isConsistent() const;
      int divSize() const;

      void getPV(const HashKey&, MoveVector&, size_t *quiesce_start=0) const;
    };
    
  } // namespace search

  using search::SimpleHashTable;
} // namespace osl

#endif /* _SIMPLE_HASHTABLE_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
