/* activityCount.h
 */
#ifndef _STAT_ACTIVITYCOUNT_H
#define _STAT_ACTIVITYCOUNT_H

#include <boost/scoped_array.hpp>
#include <cassert>

namespace osl
{
  namespace stat
  {
    class ActivityCount
    {
    protected:
      boost::scoped_array<int> counts;
      const unsigned int length;
    public:
      explicit ActivityCount(unsigned int length);
      ~ActivityCount();

      void clear();
      void add(unsigned int index, unsigned int count=1)
      {
	assert(index < length);
	counts[index] += count;
      }
      void show(const char *filename) const;
      /**
       * threshold ʲΥȥ0ˤ
       */
      void setBinary(int threshold);
      void loadBinary(const char *filename, int threshold);
      bool isActive(unsigned int index) const
      {
	assert(index < length);
	return counts[index];
      }
    };
  } // namespace stat
} // namespace osl


#endif /* _STAT_ACTIVITYCOUNT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
