/* Preconditioner.h
 */
#ifndef _STAT_PRECONDITIONER_H
#define _STAT_PRECONDITIONER_H

#include <cstddef>
namespace osl
{
  namespace stat
  {

    class Preconditioner
    {
    public:
      // CREATORS
      Preconditioner();
      virtual ~Preconditioner();
      // MANIPULATORS
      // ACCESSORS
      virtual void solve(const double*x, double *out) const=0;
    };

    class IdentityPreconditioner : public Preconditioner
    {
      size_t m_dim;
    public:
      // CREATORS
      explicit IdentityPreconditioner(size_t dim);
      ~IdentityPreconditioner();
      // MANIPULATORS
      // ACCESSORS
      void solve(const double*x, double *out) const;
    };

  } // namespace stat
} // namespace osl

#endif /* _STAT_PRECONDITIONER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
