/* hash_set.h
 */
#ifndef HASH_SET_H
#define HASH_SET_H

#include "osl/stl/hash.h"
#include "osl/stl/pool_allocator.h"
#include <ext/hash_set>

namespace osl
{
  namespace stl
  {
    template<class Value, class HashFun=hash<Value>,
	     class Equal=std::equal_to<Value> >
    struct hash_set
      : public __gnu_cxx::hash_set<Value, HashFun, Equal, pool_allocator<Value> >
    {
      typedef __gnu_cxx::hash_set<Value, HashFun, Equal,
				  pool_allocator<Value> > base_t;
      hash_set() {}
      hash_set(size_t s) : base_t(s)
      {
      }
    };
  } // namespace stl
  using stl::hash_set;
} // namespace stl

#endif /* HASH_SET_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
