/* moveEvaluation.cc
 */
#include "osl/category/moveEvaluation.h"
#include "osl/category/categoryUtil.h"
#include "osl/checkmate/checkmateIfCapture.h"
#include "osl/effect_util/shadowEffect.h"
#include "osl/search/historyTable.h"

int osl::category::
MoveEvaluation::evalDetailed(const CategoryEnv& env, Move move,
			     const Position8& sendoffs)
{
  const NumEffectState& state = *env.state;
  int diff = evalLight(state, move);
  if (env.history_table)
    diff = std::min(diff, env.history_table->logp(move));
  
  // ȵͤߤߺ
  if (diff < 0) // Ŭ
  {
    if (checkmate::CheckmateIfCapture::effectiveAttack
	(const_cast<NumEffectState&>(state), move, 0)) // XXX: evil cast
    {
      diff = CategoryUtilBase::CaptureIfCheckmateBonus; // Ŭ2
      if (move.capturePtype() != PTYPE_EMPTY)
      {
	diff += eval::Ptype_Eval_Table.value(move.capturePtype())
	  + eval::Ptype_Eval_Table.value(unpromote(move.capturePtype()));
      }
      if (move.isPromote())
	diff += abs(eval::Ptype_Eval_Table.promoteValue(move.ptypeO()));
    }
  }

  // ߺ
  if (sendoffs.isMember(move.to()))
    diff = std::max(diff, (const int)CategoryUtilBase::SendOffBonus);

  // εߺ
  if (diff < 0)
  {
    const int attack = state.countEffect(move.player(), move.to())
      + (move.isDrop() ? 1 : 0);
    const int defense = state.countEffect(alt(move.player()), move.to());
    if ((attack <= defense)
	&& (attack + ShadowEffect::count2(state, move.to(), move.player())
	    > defense))
      diff = 0;
  }
  return diff;
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
