/* probTable.cc
 */
#include "osl/category/probTable.h"
#include "osl/category/probTable.tcc"
#include "osl/eval/ptypeEvalTraits.h"

template class osl::category::ProbTable<172>;
template class osl::category::ProbTable<1>;
#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
template class osl::category::ProbTable<86>;
template class osl::category::ProbTable<44032>;
#endif

/* ------------------------------------------------------------------------- */
osl::category::
FixedValueTable::FixedValueTable(const char *home, const char *name)
  : base_t(home, name)
{
  assert(initialized());
  assert(min == prob[0]);
}
osl::category::
FixedValueTable::FixedValueTable(size_t val)
{
  prob[0] = val;
  min = val;
  filename[0] = 'f';
  assert(initialized());
}

/* ------------------------------------------------------------------------- */
osl::category::PieceValueTable::
PieceValueTable(const char *home, const char *name)
  : base_t(home, name)
{
}

void osl::category::PieceValueTable::
interpolate()
{
  const size_t capture_bonus_index = getIndex(eval::PtypeEvalTraits<LANCE>::val*2);
  int lastVal = CategoryTraits::maxProb();
  for (size_t i=0; i<indexMax(); ++i)
  {
    if (i >= capture_bonus_index)
      prob[i] = std::min(300, prob[i]);
    if (prob[i] == 0)
    {
      prob[i] = lastVal;	// 0 ä(갭֤)Ƥ
    }
    else
    {
      lastVal = prob[i];
    }
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
