/* standardMoveGenerator.cc
 */
#include "osl/category/standardMoveGenerator.h"
#include "osl/category/categoryListUtil.h"
#include "osl/category/categoryListUtil.tcc"
#include "osl/category/classify.tcc"
#include "osl/category/probTable.tcc"
#include "osl/state/numEffectState.h"
#include "osl/search/searchMoveSet.h"

namespace osl
{
#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
  template void category::CategoryListUtil::generate<category::BigramAttack>(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::BreakThreatmate>(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::ImmediateEscape>(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::AddEffectToLastMove>(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::Escape<ROOK> >(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::Escape<BISHOP> >(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::StandardClassifier>(CategoryEnv const&, container::MoveLogProbVector&);
  template void category::CategoryListUtil::generate<category::Pass>(CategoryEnv const&, container::MoveLogProbVector&);
#endif

  namespace category
  {
    // explicit instantiation
    template void CategoryListUtil::
    gatherAllMoves<StandardMoveGenerator>(const CategoryEnv&, MoveLogProbSet&);
    template void CategoryListUtil::
    gatherAllMoves<StandardMoveGenerator>(const CategoryEnv&, SearchMoveSet&);
  } // namespace category
} // namespace category

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
