#include "osl/container/pieceVector.h"
#include "osl/eval/pieceEval.h"
#include <algorithm>
#include <iostream>

namespace osl
{
  struct PieceBasicLessThan
  {
    bool operator()(Piece p0,Piece p1){
      const Ptype ptype0=unpromote(p0.ptype());
      const Ptype ptype1=unpromote(p1.ptype());
      return (eval::Ptype_Eval_Table.value(ptype0)
	      < eval::Ptype_Eval_Table.value(ptype1));
    }
  };
  struct PiecePtypeMoreThan
  {
    bool operator()(Piece p0,Piece p1){
      const PtypeO ptypeo0=p0.ptypeO();
      const PtypeO ptypeo1=p1.ptypeO();
      return (abs(eval::Ptype_Eval_Table.captureValue(ptypeo0))
	      > abs(eval::Ptype_Eval_Table.captureValue(ptypeo1)));
    }
  };
} // namespace osl

void osl::container::PieceVector::sortByBasic()
{
  std::sort(begin(),end(),PieceBasicLessThan());
}

void osl::container::PieceVector::sortByPtype()
{
  std::sort(begin(),end(),PiecePtypeMoreThan());
}

std::ostream& osl::container::operator<<(std::ostream& os,PieceVector const& pv)
{
  os << "PieceVector";
  for(size_t i=0; i<pv.size(); i++) {
    os << " " << pv[i];
  }
  return os << std::endl;
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
