/* enterKing.cc
 */
#include "osl/enter_king/enterKing.h"

bool osl::enter_king::EnterKing::canDeclareWin(const NumEffectState& state)
{
  //, ֤Ͼά
  const Player turn = state.getTurn();
  const Position myKingPosition
    = state.getKingPosition(turn);

  //꤬äƤʤ
  if ( state.hasEffectBy(alt(turn), myKingPosition) )
    return false;

  //̤Ũؤˤ뤫
  //ʤ1~3
  //ʤ7~9
  const int y = myKingPosition.y();
  const int enemyCampMin = (turn==BLACK) ? 1 : 7;
  const int enemyCampMax = enemyCampMin + 2;

  if( (y < enemyCampMin) || (y > enemyCampMax) )
    return false;

  // Ũؤ˼ʬζ10ʾ (̤) 뤫
  // ꤹ.  (о: Ũؤζ + )
  // 5Ȥ, 28, ʤ27ɬ
  int countPiece = 0;
  int onEnemyCamp = -1; // ̤ʬͽƤ

  for (int i = enemyCampMin; i <= enemyCampMax; i++)
    for (int j=1; j<=9; j++){
      Piece pieceOnEnemyCamp = state.getPieceOnBoard(Position(j,i));
      countPiece += ((pieceOnEnemyCamp!=Piece::EMPTY())&&(pieceOnEnemyCamp.owner()==turn));
      if ( (pieceOnEnemyCamp!=Piece::EMPTY()) && (pieceOnEnemyCamp.owner()==turn) )
	onEnemyCamp += 1 + 4 * ( (pieceOnEnemyCamp.ptype()==ROOK) || 
				 (pieceOnEnemyCamp.ptype()==PROOK) || 
				 (pieceOnEnemyCamp.ptype()==BISHOP) || 
				 (pieceOnEnemyCamp.ptype()==PBISHOP) );
    }

  if (countPiece < 11)
    return false;

  int onStand =
      5 * state.countPiecesOnStand(turn, ROOK)
    + 5 * state.countPiecesOnStand(turn, BISHOP)
    + state.countPiecesOnStand(turn, GOLD)
    + state.countPiecesOnStand(turn, SILVER)
    + state.countPiecesOnStand(turn, KNIGHT)
    + state.countPiecesOnStand(turn, LANCE)
    + state.countPiecesOnStand(turn, PAWN);

  if ( onEnemyCamp + onStand < 27 + (turn==BLACK) )
    return false;

  return true;
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
