/* alphaBetaPlayer.cc
 */
#include "osl/game_playing/alphaBetaPlayer.h"
#include "osl/game_playing/searchPlayer.tcc"
#include "osl/search/alphaBeta2.h"
#include "osl/search/simpleHashTable.h"
#include "osl/eval/progressEval.h"
#include "osl/eval/pieceEval.h"
#include "osl/category/standardMoveGenerator.h"

osl::game_playing::
AlphaBeta2Player::AlphaBeta2Player()
{
}

osl::game_playing::
AlphaBeta2Player::~AlphaBeta2Player()
{
}

osl::game_playing::ComputerPlayer* osl::game_playing::
AlphaBeta2Player::clone() const 
{
  return cloneIt(*this);
}

const osl::game_playing::MoveWithComment osl::game_playing::
AlphaBeta2Player::searchWithSecondsForThisMove(const GameState& gs, int seconds)
{
  const int consumed = setUpTable(gs, 0);
  if (seconds > 0)
    seconds = std::max(1, seconds-consumed);
  searcher.reset();
  searcher.reset(new AlphaBeta2(gs.state(), *checkmate_ptr, table_ptr.get(),
				*recorder_ptr));
  return SearchPlayer::search<AlphaBeta2>(gs, seconds);
}

bool osl::game_playing::
AlphaBeta2Player::isReasonableMove(const GameState& gs,
				   Move move, int pawn_sacrifice)
{
  setUpTable(gs, 0);
  AlphaBeta2 searcher(gs.state(), *checkmate_ptr, table_ptr.get(),
		      *recorder_ptr);  
  return SearchPlayer::isReasonableMoveBySearch(searcher, move, pawn_sacrifice);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
