/* generateCaptureMoves.cc
 */
#include "osl/move_generator/capture_.h"
#include "osl/move_generator/capture_.tcc"
#include "osl/move_action/store.h"
#include "osl/move_action/notKingOpenFilter.h"
#if 0
#  include "osl/move_action/checkFilter.h"
#endif
#include "osl/container/moveVector.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace move_generator
  {
    using namespace move_action;
    // explicit template instantiation
    template void GenerateCapture::generate(Player,const NumEffectState&, 
					    Position, Store&);

    // escape
    template void GenerateCapture::escapeByCapture
    (Player,const NumEffectState&, Position, Piece, Store&);
    typedef NotKingOpenFilter<BLACK,NumEffectState,Store> not_open_black_t;
    typedef NotKingOpenFilter<WHITE,NumEffectState,Store> not_open_white_t;
    template void Capture<BLACK>::escapeByCapture
    (const NumEffectState&, Position, Piece, not_open_black_t&);
    template void Capture<WHITE>::escapeByCapture
    (const NumEffectState&, Position, Piece, not_open_white_t&);

#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
    template void Capture<BLACK>::
    escapeByCapture<NumEffectState, Store>(NumEffectState const&, Position, Piece, Store&);
    template void Capture<WHITE>::
    escapeByCapture<NumEffectState, Store>(NumEffectState const&, Position, Piece, Store&);
    template void osl::move_generator::Capture<(osl::Player)0>::generate<osl::NumSimpleEffect<osl::PawnMaskState>, osl::move_action::Store>(osl::NumSimpleEffect<osl::PawnMaskState> const&, osl::Position, osl::move_action::Store&);
    template void osl::move_generator::Capture<(osl::Player)-1>::generate<osl::NumSimpleEffect<osl::PawnMaskState>, osl::move_action::Store>(osl::NumSimpleEffect<osl::PawnMaskState> const&, osl::Position, osl::move_action::Store&);
#endif
  } // namespace move_generator
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
