/* legalMoves.cc
 */
#include "osl/move_generator/legalMoves.h"
#include "osl/move_classifier/moveAdaptor.h"
#include "osl/move_classifier/pawnDropCheckmate.h"
#include "osl/move_classifier/safeMove.h"
#include "osl/move_generator/allMoves.h"
#include "osl/move_generator/escape_.h"
#include "osl/container/moveVector.h"
#include "osl/effect_util/effectUtil.h"

void osl::move_generator::
LegalMoves::generate(const NumEffectState& state, MoveVector& moves)
{
  if (EffectUtil::isKingInCheck(state.getTurn(), state))
  {
    // ꤬äƤɤΤߤ
    GenerateEscapeKing::generate(state, moves);
  }
  else
  {
    // ǤʤƤμ
    MoveVector all_moves;
    GenerateAllMoves::generate(state.getTurn(), state, all_moves);
    // λؼϡ̤ȴäꡤͤβǽΤ
    // ǧɬ
    using namespace osl::move_classifier;
    for (unsigned int i=0; i<all_moves.size(); ++i)
    {
      const Move m = all_moves[i];
      if (m.isDrop()
	  || PlayerMoveAdaptor<SafeMove>::isMember(state, m))
      {
	if (! PlayerMoveAdaptor<PawnDropCheckmate>::isMember(state, m))
	{
	  moves.push_back(m);
	}
      }
    }
  }
}

