/* effect5x3d.cc
 */
#include "osl/progress/effect5x3d.h"
#include "osl/progress/effect5x3Table.h"

int osl::progress::
Effect5x3d::makeProgress(Player defense, const NumEffectState& state,
			 Position king)
{
  
  const Position center = Centering5x3::adjustCenter(king);

  const int min_x = center.x() - 2;
  const int min_y = center.y() - 1;

  // 
  int sum_effect = 0;

   for (int dx=0; dx<5; ++dx)
    {
      for (int dy=0; dy<3; ++dy)
	{
	  const Position target(min_x+dx,min_y+dy);
	  sum_effect += state.countEffect(defense, target) *
	    Effect5x3_Table.getDefenseEffect(defense,king,dx,dy);
	}
    }

  return sum_effect / 2;
}

void osl::progress::
Effect5x3d::update(const NumEffectState& new_state, Move last_move)
{
  progresses[playerToIndex(BLACK)]=makeProgress(BLACK,new_state,new_state.getKingPosition<BLACK>());
  progresses[playerToIndex(WHITE)]=makeProgress(WHITE,new_state,new_state.getKingPosition<WHITE>());
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
