/* positionGroup.cc
 */
#include "osl/rating/group/positionGroup.h"

osl::rating::
RelativeKingXGroup::RelativeKingXGroup(bool a) : Group(a ? "KingRelAX" : "KingRelDX"), attack(a)
{
  for (int x=0; x<9; ++x) {
    for (int s=PTYPE_PIECE_MIN; s<=PTYPE_BASIC_MIN; ++s) { // we cannot drop KING 
      push_back(new RelativeKingX(x, a, static_cast<Ptype>(s), false));
    }
    for (int s=PTYPE_BASIC_MIN+1; s<=PTYPE_MAX; ++s) {
      push_back(new RelativeKingX(x, a, static_cast<Ptype>(s), false));
      push_back(new RelativeKingX(x, a, static_cast<Ptype>(s), true));
    }
  }
}

osl::rating::PositionXGroup::PositionXGroup() : Group("PositionX")
{
  for (int x=1; x<=5; ++x) {
    for (int s=PTYPE_PIECE_MIN; s<=PTYPE_BASIC_MIN; ++s) { // we cannot drop KING 
      push_back(new PositionX(x, static_cast<Ptype>(s), false));
    }
    for (int s=PTYPE_BASIC_MIN+1; s<=PTYPE_MAX; ++s) {
      push_back(new PositionX(x, static_cast<Ptype>(s), false));
      push_back(new PositionX(x, static_cast<Ptype>(s), true));
    }
  }
}

osl::rating::PositionYGroup::PositionYGroup() : Group("PositionY")
{
  for (int y=1; y<=9; ++y) {
    for (int s=PTYPE_PIECE_MIN; s<=PTYPE_BASIC_MIN; ++s) { // we cannot drop KING 
      push_back(new PositionY(y, static_cast<Ptype>(s), false));
    }
    for (int s=PTYPE_BASIC_MIN+1; s<=PTYPE_MAX; ++s) {
      push_back(new PositionY(y, static_cast<Ptype>(s), false));
      push_back(new PositionY(y, static_cast<Ptype>(s), true));
    }
  }
}

/* ------------------------------------------------------------------------- */
