/* DiagonalPreconditioner.cc
 */
#include "osl/stat/diagonalPreconditioner.h"
#include <algorithm>
#include <stdexcept>

// CREATORS
osl::stat::
DiagonalPreconditioner::DiagonalPreconditioner(size_t dim)
  : m_diagonals(new double[dim]), m_dim(dim)
{
  std::fill(&m_diagonals[0], &m_diagonals[dim], 0.0);
}

osl::stat::
DiagonalPreconditioner::~DiagonalPreconditioner()
{
}

// MANIPULATORS
void osl::stat::
DiagonalPreconditioner::setInverseDiagonals(const double *inverse_diagonals)
{
  std::copy(inverse_diagonals, inverse_diagonals+m_dim, &m_diagonals[0]);
}

// ACCESSORS
void osl::stat::
DiagonalPreconditioner::solve(const double*x, double *out) const
{
  for (size_t i=0; i<m_dim; ++i)
  {
    out[i] = x[i]*m_diagonals[i];
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
