/* alarm.t.cc
 */
#include "osl/misc/alarm.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

using namespace osl;

class AlarmTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(AlarmTest);
  CPPUNIT_TEST(testOne);
  CPPUNIT_TEST_SUITE_END();
public:
  void testOne();
};


void AlarmTest::
testOne()
{
  volatile int alarm_caught = 0;
  AlarmSwitch notify(&alarm_caught);
  Alarm::set(1, notify);
  pause();
  CPPUNIT_ASSERT(alarm_caught);
  Alarm::reset(notify);
}

CPPUNIT_TEST_SUITE_REGISTRATION(AlarmTest);

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
